package org.openxma.dsl.reference.base.model.impl;

import java.util.Date;
import org.openxma.dsl.reference.base.model.BaseEntity;

public abstract class BaseEntityGenImpl implements BaseEntity {
	protected String oid;
	protected Date version;
    
	public String getOid() {
		return this.oid;
	}
	
	public void setOid(String oid) {
		this.oid = oid;
	}

	public Date getVersion() {
		return this.version;
	}
	
	public void setVersion(Date version) {
		this.version = version;
	}
	
    @Override
    public int hashCode() {
    	final int prime = 31;
		int result = 1;
		result = prime * result + ((getOid() == null) ? 0 : getOid().hashCode());
		return result;
    }

    @Override
    public boolean equals(Object obj) {
    	if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (!(obj instanceof BaseEntity)) {
			return false;
		}
		BaseEntity other = (BaseEntity) obj;
		if (getOid() == null) {
			if (other.getOid() != null) {
				return false;
			}
		} else if (!getOid().equals(other.getOid())) {
			return false;
		}
		return true;
    }
	
    @Override
    public String toString() {
    	return new StringBuilder("BaseEntity [")
        	.append("oid=").append(getOid()).append(",")
        	.append("version=").append(getVersion())
        	.append("]")
            .toString();
    }
}
