package org.openxma.dsl.reference.dao.impl;

import org.openxma.dsl.platform.dao.*;
import org.openxma.dsl.platform.dao.impl.*;

import org.hibernate.Criteria;
import org.hibernate.Query;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Criterion;
import org.hibernate.criterion.Expression;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.jdbc.support.incrementer.DataFieldMaxValueIncrementer;
import org.springframework.stereotype.Repository;
import org.springframework.util.Assert;
import org.openxma.dsl.reference.dao.AddressDao;
import org.openxma.dsl.reference.model.Address;
import org.openxma.dsl.reference.model.impl.AddressImpl;
/**
 * @see AddressDao
 */
@SuppressWarnings("unused")
public abstract class AddressDaoGenImpl extends GenericDaoHibernateImpl<Address,String> implements AddressDao {
    /**
     * @param sessionFactory the sessionFactory to set
     */
    @Autowired
    public void setSessionFactory(@Qualifier("default") SessionFactory sessionFactory) {
        this.sessionFactory = sessionFactory;
    }
    /**
     * @param dataFieldMaxValueIncrementer the dataFieldMaxValueIncrementer to set
     */
    @Autowired
    public void setDataFieldMaxValueIncrementer(@Qualifier("default")
            DataFieldMaxValueIncrementer dataFieldMaxValueIncrementer) {
        this.dataFieldMaxValueIncrementer = dataFieldMaxValueIncrementer;
    }

    public AddressDaoGenImpl() {
        super(AddressImpl.class);
    }
    
    /**
     * @param context the context for the object creation
     * @return a transient instance of entity <code>Address</code> with an already assigned identifier.
     */
    public Address createEntity(Object context) {
        return create();
    }

    public Address create()
    {
        AddressImpl address = new AddressImpl();
        address.setOid(dataFieldMaxValueIncrementer.nextStringValue());
        return address;
    }
}
