package org.openxma.dsl.reference.dao.impl;

import org.openxma.dsl.platform.dao.*;
import org.openxma.dsl.platform.dao.impl.*;

import org.hibernate.Criteria;
import org.hibernate.Query;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Criterion;
import org.hibernate.criterion.Expression;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.jdbc.support.incrementer.DataFieldMaxValueIncrementer;
import org.springframework.stereotype.Repository;
import org.springframework.util.Assert;
import org.openxma.dsl.reference.dao.BugDao;
import org.openxma.dsl.reference.model.Bug;
import org.openxma.dsl.reference.model.impl.BugImpl;
/**
 * @see BugDao
 */
@SuppressWarnings("unused")
public abstract class BugDaoGenImpl extends GenericDaoHibernateImpl<Bug,Long> implements BugDao {
    /**
     * @param sessionFactory the sessionFactory to set
     */
    @Autowired
    public void setSessionFactory(@Qualifier("default") SessionFactory sessionFactory) {
        this.sessionFactory = sessionFactory;
    }
    /**
     * @param dataFieldMaxValueIncrementer the dataFieldMaxValueIncrementer to set
     */
    @Autowired
    public void setDataFieldMaxValueIncrementer(@Qualifier("default")
            DataFieldMaxValueIncrementer dataFieldMaxValueIncrementer) {
        this.dataFieldMaxValueIncrementer = dataFieldMaxValueIncrementer;
    }

    public BugDaoGenImpl() {
        super(BugImpl.class);
    }
    
    /**
     * @param context the context for the object creation
     * @return a transient instance of entity <code>Bug</code> with an already assigned identifier.
     */
    public Bug createEntity(Object context) {
        return create();
    }

    public Bug create()
    {
        BugImpl bug = new BugImpl();
        bug.setOid(Long.valueOf(dataFieldMaxValueIncrementer.nextLongValue()));
        return bug;
    }

    public Bug create(String bugId) {
        Assert.notNull(bugId, "Parameter 'bugId' must not be null");
        Bug bug = (Bug) create();
        bug.setBugId(bugId);
        return bug;
    }
    
    public Bug createAndSave(String bugId) {
        Bug bug = create(bugId);
        saveOrUpdate(bug);
        return bug;
    }
}
