package org.openxma.dsl.reference.dao.impl;

import org.openxma.dsl.platform.dao.*;
import org.openxma.dsl.platform.dao.impl.*;

import org.hibernate.Criteria;
import org.hibernate.Query;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Criterion;
import org.hibernate.criterion.Expression;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.jdbc.support.incrementer.DataFieldMaxValueIncrementer;
import org.springframework.stereotype.Repository;
import org.springframework.util.Assert;
import org.openxma.dsl.reference.dao.VODataDao;
import org.openxma.dsl.reference.model.VOData;
import org.openxma.dsl.reference.model.impl.VODataImpl;
/**
 * @see VODataDao
 */
@SuppressWarnings("unused")
public abstract class VODataDaoGenImpl extends GenericDaoHibernateImpl<VOData,String> implements VODataDao {
    /**
     * @param sessionFactory the sessionFactory to set
     */
    @Autowired
    public void setSessionFactory(@Qualifier("default") SessionFactory sessionFactory) {
        this.sessionFactory = sessionFactory;
    }
    /**
     * @param dataFieldMaxValueIncrementer the dataFieldMaxValueIncrementer to set
     */
    @Autowired
    public void setDataFieldMaxValueIncrementer(@Qualifier("default")
            DataFieldMaxValueIncrementer dataFieldMaxValueIncrementer) {
        this.dataFieldMaxValueIncrementer = dataFieldMaxValueIncrementer;
    }

    public VODataDaoGenImpl() {
        super(VODataImpl.class);
    }
    
    /**
     * @param context the context for the object creation
     * @return a transient instance of entity <code>VOData</code> with an already assigned identifier.
     */
    public VOData createEntity(Object context) {
        return create();
    }

    public VOData create()
    {
        VODataImpl vOData = new VODataImpl();
        vOData.setOid(dataFieldMaxValueIncrementer.nextStringValue());
        return vOData;
    }
}
