package org.openxma.dsl.reference.dto;

import java.io.Serializable;
import org.openxma.dsl.platform.dao.EntityFactory;
import org.openxma.dsl.platform.service.MapperContextHolder;
import java.util.Date;
import org.openxma.dsl.platform.service.EntityMapperSupport;
import org.openxma.dsl.reference.model.Address;

public abstract class AddressViewGen implements Serializable,EntityMapperSupport {
	private static final long serialVersionUID = 641328332;
	protected String oid;
	protected Date version;
	protected String streetName;
	protected String streetNumber;
	protected String zip;
	protected String city;
	protected String country;
	
	public String getOid() {
        return this.oid;
    }
	
	public void setOid(String oid) {
        this.oid=oid;
    }
	
	public Date getVersion() {
        return this.version;
    }
	
	public void setVersion(Date version) {
        this.version=version;
    }
	
	public String getStreetName() {
        return this.streetName;
    }
	
	public void setStreetName(String streetName) {
        this.streetName=streetName;
    }
	
	public String getStreetNumber() {
        return this.streetNumber;
    }
	
	public void setStreetNumber(String streetNumber) {
        this.streetNumber=streetNumber;
    }
	
	public String getZip() {
        return this.zip;
    }
	
	public void setZip(String zip) {
        this.zip=zip;
    }
	
	public String getCity() {
        return this.city;
    }
	
	public void setCity(String city) {
        this.city=city;
    }
	
	public String getCountry() {
        return this.country;
    }
	
	public void setCountry(String country) {
        this.country=country;
    }
	
    public void mapFrom(Object sourceObject) {
    	if (sourceObject instanceof Address) {
    		Address address = (Address) sourceObject;
    		internalMapFromAddress(address);	
    	} 
    	else if (sourceObject != null) {
			throw new IllegalArgumentException("mapping from object '"+sourceObject+"' is not supported");
		}
	}
	
	public <T> T mapTo(Class<T> target) {
		if (AddressView.class.equals(target)) { 
			AddressView addressView = new AddressView();
			internalMapToAddressView(addressView);		
			return target.cast(addressView);
		}
		else if (Address.class.equals(target)) {
    		return target.cast(internalMapToAddress(target));
    	}
    	else { 
    		throw new IllegalArgumentException("mapping to class '"+target+"' is not supported");
    	}
    }
	
    public void mapTo(Object targetObject) {
    	if (targetObject instanceof AddressView) { 
			internalMapToAddressView(((AddressView)targetObject));		
		}
    	else if (targetObject instanceof Address) {
    		internalMapToAddress(((Address)targetObject));	
    	} 
    	else if (targetObject != null) { 
			throw new IllegalArgumentException("mapping to object '"+targetObject+"' is not supported");
		}
	}
    
    protected void internalMapToAddressView(AddressView addressView) {
		addressView.setOid(getOid());
		addressView.setVersion(getVersion());
		addressView.setStreetName(getStreetName());
		addressView.setStreetNumber(getStreetNumber());
		addressView.setZip(getZip());
		addressView.setCity(getCity());
		addressView.setCountry(getCountry());
    }
    
    protected Address internalMapToAddress(Class<?> target) {
    	EntityFactory<Address> entityFactory = (EntityFactory<Address>) 
    		MapperContextHolder.getEntityFactoryRegistry().getEntityFactory(Address.class);
    	Address address = (Address) 
    		entityFactory.createEntity(null);
    	internalMapToAddress(address);	
    	return address;
    }
    
    protected void internalMapToAddress(Address address) {
    	if (!MapperContextHolder.getContext().containsKey(this)) {
	    	MapperContextHolder.getContext().put(this, address);
			if (getOid() != null) {
				address.setOid(getOid());
			}
			address.setVersion(getVersion());
			address.setStreetName(getStreetName());
			address.setStreetNumber(getStreetNumber());
			address.setZip(getZip());
			address.setCity(getCity());
			address.setCountry(getCountry());
	    }
	}
	
	protected void internalMapFromAddress(Address address) {
		if (!MapperContextHolder.getContext().containsKey(address)) {
	    	MapperContextHolder.getContext().put(address, this);			
			setOid(address.getOid());
			setVersion(address.getVersion());
			setStreetName(address.getStreetName());
			setStreetNumber(address.getStreetNumber());
			setZip(address.getZip());
			setCity(address.getCity());
			setCountry(address.getCountry());
		}
	}
    
    @Override
    public String toString() {
    	return new StringBuilder("AddressView [")
        	.append("oid=").append(getOid()).append(",")
        	.append("version=").append(getVersion()).append(",")
        	.append("streetName=").append(getStreetName()).append(",")
        	.append("streetNumber=").append(getStreetNumber()).append(",")
        	.append("zip=").append(getZip()).append(",")
        	.append("city=").append(getCity()).append(",")
        	.append("country=").append(getCountry())
        	.append("]")
            .toString();
    }
}
