package org.openxma.dsl.reference.dto;

import java.io.Serializable;
import org.openxma.dsl.platform.dao.EntityFactory;
import org.openxma.dsl.platform.service.MapperContextHolder;
import org.openxma.dsl.reference.dto.CustomerIdDto;
import org.openxma.dsl.reference.model.Customer;
import org.openxma.dsl.reference.types.valueobject.TelefonNumber;

public abstract class CustomerContactReportGen extends CustomerIdDto implements Serializable {
	private static final long serialVersionUID = -591632474;
	protected String firstName;
	protected String lastName;
	protected String emailAddress;
	protected TelefonNumber telefonNumber;
	
	public String getFirstName() {
        return this.firstName;
    }
	
	public void setFirstName(String firstName) {
        this.firstName=firstName;
    }
	
	public String getLastName() {
        return this.lastName;
    }
	
	public void setLastName(String lastName) {
        this.lastName=lastName;
    }
	
	public String getEmailAddress() {
        return this.emailAddress;
    }
	
	public void setEmailAddress(String emailAddress) {
        this.emailAddress=emailAddress;
    }
	
	public TelefonNumber getTelefonNumber() {
        return this.telefonNumber;
    }
	
	public void setTelefonNumber(TelefonNumber telefonNumber) {
        this.telefonNumber=telefonNumber;
    }
	
    public void mapFrom(Object sourceObject) {
    	if (sourceObject instanceof Customer) {
    		Customer customer = (Customer) sourceObject;
    		internalMapFromCustomer(customer);	
    	} 
    	else {
			super.mapFrom(sourceObject);
		}
	}
	
	public <T> T mapTo(Class<T> target) {
		if (CustomerContactReport.class.equals(target)) { 
			CustomerContactReport customerContactReport = new CustomerContactReport();
			internalMapToCustomerContactReport(customerContactReport);		
			return target.cast(customerContactReport);
		}
		else if (Customer.class.equals(target)) {
    		return target.cast(internalMapToCustomer(target));
    	}
    	else {
			return super.mapTo(target);
		}
    }
	
    public void mapTo(Object targetObject) {
    	if (targetObject instanceof CustomerContactReport) { 
			internalMapToCustomerContactReport(((CustomerContactReport)targetObject));		
		}
    	else if (targetObject instanceof Customer) {
    		internalMapToCustomer(((Customer)targetObject));	
    	} 
    	else {
			super.mapTo(targetObject);
		}
	}
    
    protected void internalMapToCustomerContactReport(CustomerContactReport customerContactReport) {
		customerContactReport.setFirstName(getFirstName());
		customerContactReport.setLastName(getLastName());
		customerContactReport.setEmailAddress(getEmailAddress());
		customerContactReport.setTelefonNumber(getTelefonNumber());
    }
    
    protected Customer internalMapToCustomer(Class<?> target) {
    	EntityFactory<Customer> entityFactory = (EntityFactory<Customer>) 
    		MapperContextHolder.getEntityFactoryRegistry().getEntityFactory(Customer.class);
    	Customer customer = (Customer) 
    		entityFactory.createEntity(null);
    	internalMapToCustomer(customer);	
    	return customer;
    }
    
    protected void internalMapToCustomer(Customer customer) {
    	if (!MapperContextHolder.getContext().containsKey(this)) {
	        super.internalMapToCustomer(customer);
			customer.setFirstName(getFirstName());
			customer.setLastName(getLastName());
			customer.setEmailAddress(getEmailAddress());
			customer.setTelefonNumber(getTelefonNumber());
	    }
	}
	
	protected void internalMapFromCustomer(Customer customer) {
		if (!MapperContextHolder.getContext().containsKey(customer)) {
	        super.internalMapFromCustomer(customer);
			setFirstName(customer.getFirstName());
			setLastName(customer.getLastName());
			setEmailAddress(customer.getEmailAddress());
			setTelefonNumber(customer.getTelefonNumber());
		}
	}
    
    @Override
    public String toString() {
    	return new StringBuilder("CustomerContactReport [")
    		.append(super.toString()).append(",")
        	.append("firstName=").append(getFirstName()).append(",")
        	.append("lastName=").append(getLastName()).append(",")
        	.append("emailAddress=").append(getEmailAddress()).append(",")
        	.append("telefonNumber=").append(getTelefonNumber())
        	.append("]")
            .toString();
    }
}
