package org.openxma.dsl.reference.dto;

import java.io.Serializable;
import org.openxma.dsl.platform.dao.EntityFactory;
import org.openxma.dsl.platform.service.MapperContextHolder;
import org.openxma.dsl.platform.service.EntityMapperSupport;
import org.openxma.dsl.reference.model.Customer;

public abstract class CustomerIdDtoGen implements Serializable,EntityMapperSupport {
	private static final long serialVersionUID = 110026;
	protected String oid;
	
	public String getOid() {
        return this.oid;
    }
	
	public void setOid(String oid) {
        this.oid=oid;
    }
	
    public void mapFrom(Object sourceObject) {
    	if (sourceObject instanceof Customer) {
    		Customer customer = (Customer) sourceObject;
    		internalMapFromCustomer(customer);	
    	} 
    	else if (sourceObject != null) {
			throw new IllegalArgumentException("mapping from object '"+sourceObject+"' is not supported");
		}
	}
	
	public <T> T mapTo(Class<T> target) {
		if (CustomerIdDto.class.equals(target)) { 
			CustomerIdDto customerIdDto = new CustomerIdDto();
			internalMapToCustomerIdDto(customerIdDto);		
			return target.cast(customerIdDto);
		}
		else if (Customer.class.equals(target)) {
    		return target.cast(internalMapToCustomer(target));
    	}
    	else { 
    		throw new IllegalArgumentException("mapping to class '"+target+"' is not supported");
    	}
    }
	
    public void mapTo(Object targetObject) {
    	if (targetObject instanceof CustomerIdDto) { 
			internalMapToCustomerIdDto(((CustomerIdDto)targetObject));		
		}
    	else if (targetObject instanceof Customer) {
    		internalMapToCustomer(((Customer)targetObject));	
    	} 
    	else if (targetObject != null) { 
			throw new IllegalArgumentException("mapping to object '"+targetObject+"' is not supported");
		}
	}
    
    protected void internalMapToCustomerIdDto(CustomerIdDto customerIdDto) {
		customerIdDto.setOid(getOid());
    }
    
    protected Customer internalMapToCustomer(Class<?> target) {
    	EntityFactory<Customer> entityFactory = (EntityFactory<Customer>) 
    		MapperContextHolder.getEntityFactoryRegistry().getEntityFactory(Customer.class);
    	Customer customer = (Customer) 
    		entityFactory.createEntity(null);
    	internalMapToCustomer(customer);	
    	return customer;
    }
    
    protected void internalMapToCustomer(Customer customer) {
    	if (!MapperContextHolder.getContext().containsKey(this)) {
	    	MapperContextHolder.getContext().put(this, customer);
			if (getOid() != null) {
				customer.setOid(getOid());
			}
	    }
	}
	
	protected void internalMapFromCustomer(Customer customer) {
		if (!MapperContextHolder.getContext().containsKey(customer)) {
	    	MapperContextHolder.getContext().put(customer, this);			
			setOid(customer.getOid());
		}
	}
    
    @Override
    public String toString() {
    	return new StringBuilder("CustomerIdDto [")
        	.append("oid=").append(getOid())
        	.append("]")
            .toString();
    }
}
