package org.openxma.dsl.reference.dto;

import java.io.Serializable;
import org.openxma.dsl.platform.dao.EntityFactory;
import org.openxma.dsl.platform.service.MapperContextHolder;
import org.openxma.dsl.platform.service.EntityMapperSupport;
import org.openxma.dsl.reference.dto.OrderStateView;
import org.openxma.dsl.reference.dto.ProductIdView;
import org.openxma.dsl.reference.model.Order;
import org.openxma.dsl.reference.model.OrderItem;
import org.openxma.dsl.reference.model.Product;

public abstract class OrderItemQuantityViewGen implements Serializable,EntityMapperSupport {
	private static final long serialVersionUID = 1488203562;
	protected Long quantity;
	protected OrderStateView order;
	protected ProductIdView product;
	
	public Long getQuantity() {
        return this.quantity;
    }
	
	public void setQuantity(Long quantity) {
        this.quantity=quantity;
    }
	
	public OrderStateView getOrder() {
        return this.order;
    }
	
	public void setOrder(OrderStateView order) {
        this.order=order;
    }
	
	public ProductIdView getProduct() {
        return this.product;
    }
	
	public void setProduct(ProductIdView product) {
        this.product=product;
    }
	
    public void mapFrom(Object sourceObject) {
    	if (sourceObject instanceof OrderItem) {
    		OrderItem orderItem = (OrderItem) sourceObject;
    		internalMapFromOrderItem(orderItem);	
    	} 
    	else if (sourceObject != null) {
			throw new IllegalArgumentException("mapping from object '"+sourceObject+"' is not supported");
		}
	}
	
	public <T> T mapTo(Class<T> target) {
		if (OrderItemQuantityView.class.equals(target)) { 
			OrderItemQuantityView orderItemQuantityView = new OrderItemQuantityView();
			internalMapToOrderItemQuantityView(orderItemQuantityView);		
			return target.cast(orderItemQuantityView);
		}
		else if (OrderItem.class.equals(target)) {
    		return target.cast(internalMapToOrderItem(target));
    	}
    	else { 
    		throw new IllegalArgumentException("mapping to class '"+target+"' is not supported");
    	}
    }
	
    public void mapTo(Object targetObject) {
    	if (targetObject instanceof OrderItemQuantityView) { 
			internalMapToOrderItemQuantityView(((OrderItemQuantityView)targetObject));		
		}
    	else if (targetObject instanceof OrderItem) {
    		internalMapToOrderItem(((OrderItem)targetObject));	
    	} 
    	else if (targetObject != null) { 
			throw new IllegalArgumentException("mapping to object '"+targetObject+"' is not supported");
		}
	}
    
    protected void internalMapToOrderItemQuantityView(OrderItemQuantityView orderItemQuantityView) {
		orderItemQuantityView.setQuantity(getQuantity());
		orderItemQuantityView.setOrder(getOrder());
		orderItemQuantityView.setProduct(getProduct());
    }
    
    protected OrderItem internalMapToOrderItem(Class<?> target) {
    	EntityFactory<OrderItem> entityFactory = (EntityFactory<OrderItem>) 
    		MapperContextHolder.getEntityFactoryRegistry().getEntityFactory(OrderItem.class);
    	OrderItem orderItem = (OrderItem) 
    		entityFactory.createEntity(null);
    	internalMapToOrderItem(orderItem);	
    	return orderItem;
    }
    
    protected void internalMapToOrderItem(OrderItem orderItem) {
    	if (!MapperContextHolder.getContext().containsKey(this)) {
	    	MapperContextHolder.getContext().put(this, orderItem);
			orderItem.setQuantity(getQuantity());
	        if (!isContext("saveOrderItem") && !isContext("updateOrderItem")) {
		        if (getOrder() != null) {
		        	Order order = getOrder().mapTo(Order.class);
					orderItem.setOrder(order);
		        }
		        if (getProduct() != null) {
		        	Product product = getProduct().mapTo(Product.class);
					orderItem.setProduct(product);
		        }
	        } 
	    }
	}
	
	protected boolean isContext(String contextName) {
		return contextName.equals(MapperContextHolder.getContext().get("context"));
	}
	
	protected void internalMapFromOrderItem(OrderItem orderItem) {
		if (!MapperContextHolder.getContext().containsKey(orderItem)) {
	    	MapperContextHolder.getContext().put(orderItem, this);			
			setQuantity(orderItem.getQuantity());
	        if (orderItem.getOrder() != null) {
		        OrderStateView order = (OrderStateView) MapperContextHolder.getContext().get(orderItem.getOrder());
		        if (null==order) {
		        	order = new OrderStateView();
					order.mapFrom(orderItem.getOrder());
		        } 
	        	setOrder(order);
	        }
	        if (orderItem.getProduct() != null) {
		        ProductIdView product = (ProductIdView) MapperContextHolder.getContext().get(orderItem.getProduct());
		        if (null==product) {
		        	product = new ProductIdView();
					product.mapFrom(orderItem.getProduct());
		        } 
	        	setProduct(product);
	        }
		}
	}
    
    @Override
    public String toString() {
    	return new StringBuilder("OrderItemQuantityView [")
        	.append("quantity=").append(getQuantity())
        	.append("]")
            .toString();
    }
}
