package org.openxma.dsl.reference.dto;

import java.io.Serializable;
import org.openxma.dsl.platform.dao.EntityFactory;
import org.openxma.dsl.platform.service.MapperContextHolder;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import org.openxma.dsl.platform.service.EntityMapperSupport;
import org.openxma.dsl.reference.dto.OrderItemView;
import org.openxma.dsl.reference.dto.OrderView;
import org.openxma.dsl.reference.model.Customer;
import org.openxma.dsl.reference.model.Order;
import org.openxma.dsl.reference.model.OrderItem;
import org.openxma.dsl.reference.types.valueobject.OrderNumber;

public abstract class OrderViewGen implements Serializable,EntityMapperSupport {
	private static final long serialVersionUID = -591413451;
	protected List<OrderView> orders;
	protected List<OrderItemView> orderItems;
	protected String oid;
	protected Date version;
	protected OrderNumber orderNumber;
	protected String storeId;
	protected Date placementDate;
	protected Date deliveryDate;
	protected String orderState;
	protected Integer taxes;
	protected Double totalAmount;
	protected String customerOid;
	
	public List<OrderView> getOrders() {
        return this.orders;
    }
	
	public void setOrders(List<OrderView> orders) {
        this.orders=orders;
    }
    
    public void addOrders(OrderView orders) {
		if (orders == null) {
			throw new IllegalArgumentException("parameter 'orders' must not be null");
		}
		if (getOrders() == null) {
			this.orders = new ArrayList<OrderView>();
		}
		this.orders.add(orders);
	}
	
	public List<OrderItemView> getOrderItems() {
        return this.orderItems;
    }
	
	public void setOrderItems(List<OrderItemView> orderItems) {
        this.orderItems=orderItems;
    }
    
    public void addOrderItems(OrderItemView orderItems) {
		if (orderItems == null) {
			throw new IllegalArgumentException("parameter 'orderItems' must not be null");
		}
		if (getOrderItems() == null) {
			this.orderItems = new ArrayList<OrderItemView>();
		}
		this.orderItems.add(orderItems);
	}
	
	public String getOid() {
        return this.oid;
    }
	
	public void setOid(String oid) {
        this.oid=oid;
    }
	
	public Date getVersion() {
        return this.version;
    }
	
	public void setVersion(Date version) {
        this.version=version;
    }
	
	public OrderNumber getOrderNumber() {
        return this.orderNumber;
    }
	
	public void setOrderNumber(OrderNumber orderNumber) {
        this.orderNumber=orderNumber;
    }
	
	public String getStoreId() {
        return this.storeId;
    }
	
	public void setStoreId(String storeId) {
        this.storeId=storeId;
    }
	
	public Date getPlacementDate() {
        return this.placementDate;
    }
	
	public void setPlacementDate(Date placementDate) {
        this.placementDate=placementDate;
    }
	
	public Date getDeliveryDate() {
        return this.deliveryDate;
    }
	
	public void setDeliveryDate(Date deliveryDate) {
        this.deliveryDate=deliveryDate;
    }
	
	public String getOrderState() {
        return this.orderState;
    }
	
	public void setOrderState(String orderState) {
        this.orderState=orderState;
    }
	
	public Integer getTaxes() {
        return this.taxes;
    }
	
	public void setTaxes(Integer taxes) {
        this.taxes=taxes;
    }
	
	public Double getTotalAmount() {
        return this.totalAmount;
    }
	
	public void setTotalAmount(Double totalAmount) {
        this.totalAmount=totalAmount;
    }
	
	public String getCustomerOid() {
        return this.customerOid;
    }
	
	public void setCustomerOid(String customerOid) {
        this.customerOid=customerOid;
    }
	
    public void mapFrom(Object sourceObject) {
    	if (sourceObject instanceof Order) {
    		Order order = (Order) sourceObject;
    		internalMapFromOrder(order);	
    		if (order.getCustomer()!=null) {
    			setCustomerOid(order.getCustomer().getOid());
    		}
    	} 
    	else if (sourceObject instanceof Customer) {
    		Customer customer = (Customer) sourceObject;
    		internalMapFromCustomer(customer);	
    	} 
    	else if (sourceObject != null) {
			throw new IllegalArgumentException("mapping from object '"+sourceObject+"' is not supported");
		}
	}
	
	public <T> T mapTo(Class<T> target) {
		if (OrderView.class.equals(target)) { 
			OrderView orderView = new OrderView();
			internalMapToOrderView(orderView);		
			return target.cast(orderView);
		}
		else if (Order.class.equals(target)) {
    		return target.cast(internalMapToOrder(target));
    	}
		else if (Customer.class.equals(target)) {
    		return target.cast(internalMapToCustomer(target));
    	}
    	else { 
    		throw new IllegalArgumentException("mapping to class '"+target+"' is not supported");
    	}
    }
	
    public void mapTo(Object targetObject) {
    	if (targetObject instanceof OrderView) { 
			internalMapToOrderView(((OrderView)targetObject));		
		}
    	else if (targetObject instanceof Order) {
    		internalMapToOrder(((Order)targetObject));	
    	} 
    	else if (targetObject instanceof Customer) {
    		internalMapToCustomer(((Customer)targetObject));	
    	} 
    	else if (targetObject != null) { 
			throw new IllegalArgumentException("mapping to object '"+targetObject+"' is not supported");
		}
	}
    
    protected void internalMapToOrderView(OrderView orderView) {
		orderView.setOrders(getOrders());
		orderView.setOrderItems(getOrderItems());
		orderView.setOid(getOid());
		orderView.setVersion(getVersion());
		orderView.setOrderNumber(getOrderNumber());
		orderView.setStoreId(getStoreId());
		orderView.setPlacementDate(getPlacementDate());
		orderView.setDeliveryDate(getDeliveryDate());
		orderView.setOrderState(getOrderState());
		orderView.setTaxes(getTaxes());
		orderView.setTotalAmount(getTotalAmount());
		orderView.setCustomerOid(getCustomerOid());
    }
    
    protected Order internalMapToOrder(Class<?> target) {
    	EntityFactory<Order> entityFactory = (EntityFactory<Order>) 
    		MapperContextHolder.getEntityFactoryRegistry().getEntityFactory(Order.class);
    	Order order = (Order) 
    		entityFactory.createEntity(null);
    	internalMapToOrder(order);	
    	return order;
    }
    
    protected void internalMapToOrder(Order order) {
    	if (!MapperContextHolder.getContext().containsKey(this)) {
	    	MapperContextHolder.getContext().put(this, order);
			if (getOid() != null) {
				order.setOid(getOid());
			}
			order.setVersion(getVersion());
			order.setOrderNumber(getOrderNumber());
			order.setStoreId(getStoreId());
			order.setPlacementDate(getPlacementDate());
			order.setDeliveryDate(getDeliveryDate());
			order.setOrderState(getOrderState());
			order.setTaxes(getTaxes());
			order.setTotalAmount(getTotalAmount());
	        if (!isContext("saveOrder") && !isContext("updateOrder")) {
		        if (getOrderItems() != null) {
			        for (OrderItemView orderItemView : getOrderItems()) {
			    		OrderItem orderItems = orderItemView.mapTo(OrderItem.class);
			    		order.addOrderItems(orderItems);
			    	}
		    	}
	        } 
	    }
	}
	
    protected Customer internalMapToCustomer(Class<?> target) {
    	EntityFactory<Customer> entityFactory = (EntityFactory<Customer>) 
    		MapperContextHolder.getEntityFactoryRegistry().getEntityFactory(Customer.class);
    	Customer customer = (Customer) 
    		entityFactory.createEntity(null);
    	internalMapToCustomer(customer);	
    	return customer;
    }
    
    protected void internalMapToCustomer(Customer customer) {
    	if (!MapperContextHolder.getContext().containsKey(this)) {
	    	MapperContextHolder.getContext().put(this, customer);
			if (getCustomerOid() != null  && isContext("customer")) {
				customer.setOid(getCustomerOid());
			}
	        if (!isContext("saveCustomer") && !isContext("updateCustomer")) {
		        if (getOrders() != null) {
			        for (OrderView orderView : getOrders()) {
			    		Order orders = orderView.mapTo(Order.class);
			    		customer.addOrders(orders);
			    	}
		    	}
	        } 
	    }
	}
	
	protected boolean isContext(String contextName) {
		return contextName.equals(MapperContextHolder.getContext().get("context"));
	}
	
	protected void internalMapFromOrder(Order order) {
		if (!MapperContextHolder.getContext().containsKey(order)) {
	    	MapperContextHolder.getContext().put(order, this);			
			setOid(order.getOid());
			setVersion(order.getVersion());
			setOrderNumber(order.getOrderNumber());
			setStoreId(order.getStoreId());
			setPlacementDate(order.getPlacementDate());
			setDeliveryDate(order.getDeliveryDate());
			setOrderState(order.getOrderState());
			setTaxes(order.getTaxes());
			setTotalAmount(order.getTotalAmount());
			if (order.hasOrderItems()) {
				for (OrderItem orderItems : order.getOrderItems()) {
		    		OrderItemView orderItemView = (OrderItemView) MapperContextHolder.getContext().get(orderItems);
		    		if (null==orderItemView) {
			        	orderItemView = new OrderItemView();
						orderItemView.mapFrom(orderItems);
			        } 
		        	addOrderItems(orderItemView);
		    	}
			}
		}
	}
	
	protected void internalMapFromCustomer(Customer customer) {
		if (!MapperContextHolder.getContext().containsKey(customer)) {
	    	MapperContextHolder.getContext().put(customer, this);			
			setCustomerOid(customer.getOid());
			if (customer.hasOrders()) {
				for (Order orders : customer.getOrders()) {
		    		OrderView orderView = (OrderView) MapperContextHolder.getContext().get(orders);
		    		if (null==orderView) {
			        	orderView = new OrderView();
						orderView.mapFrom(orders);
			        } 
		        	addOrders(orderView);
		    	}
			}
		}
	}
    
    @Override
    public String toString() {
    	return new StringBuilder("OrderView [")
        	.append("oid=").append(getOid()).append(",")
        	.append("version=").append(getVersion()).append(",")
        	.append("orderNumber=").append(getOrderNumber()).append(",")
        	.append("storeId=").append(getStoreId()).append(",")
        	.append("placementDate=").append(getPlacementDate()).append(",")
        	.append("deliveryDate=").append(getDeliveryDate()).append(",")
        	.append("orderState=").append(getOrderState()).append(",")
        	.append("taxes=").append(getTaxes()).append(",")
        	.append("totalAmount=").append(getTotalAmount()).append(",")
        	.append("customerOid=").append(getCustomerOid())
        	.append("]")
            .toString();
    }
}
