package org.openxma.dsl.reference.dto;

import java.io.Serializable;
import org.openxma.dsl.platform.dao.EntityFactory;
import org.openxma.dsl.platform.service.MapperContextHolder;
import java.util.Date;
import org.openxma.dsl.platform.service.EntityMapperSupport;
import org.openxma.dsl.reference.base.CreditCardInfo;
import org.openxma.dsl.reference.model.Address;
import org.openxma.dsl.reference.model.PrivateCustomer;
import org.openxma.dsl.reference.types.Gender;
import org.openxma.dsl.reference.types.valueobject.TelefonNumber;

public abstract class PrivateCustomerViewGen implements Serializable,EntityMapperSupport {
	private static final long serialVersionUID = -595782023;
	protected String oid;
	protected Date version;
	protected String firstName;
	protected String lastName;
	protected Gender gender;
	protected String emailAddress;
	protected Date birthDate;
	protected TelefonNumber telefonNumber;
	protected Date lastOrderDate;
	protected CreditCardInfo ccInfo = new CreditCardInfo();
	protected String invoiceAddressOid;
	protected String deliveryAddressOid;
	
	public String getOid() {
        return this.oid;
    }
	
	public void setOid(String oid) {
        this.oid=oid;
    }
	
	public Date getVersion() {
        return this.version;
    }
	
	public void setVersion(Date version) {
        this.version=version;
    }
	
	public String getFirstName() {
        return this.firstName;
    }
	
	public void setFirstName(String firstName) {
        this.firstName=firstName;
    }
	
	public String getLastName() {
        return this.lastName;
    }
	
	public void setLastName(String lastName) {
        this.lastName=lastName;
    }
	
	public Gender getGender() {
        return this.gender;
    }
	
	public void setGender(Gender gender) {
        this.gender=gender;
    }
	
	public String getEmailAddress() {
        return this.emailAddress;
    }
	
	public void setEmailAddress(String emailAddress) {
        this.emailAddress=emailAddress;
    }
	
	public Date getBirthDate() {
        return this.birthDate;
    }
	
	public void setBirthDate(Date birthDate) {
        this.birthDate=birthDate;
    }
	
	public TelefonNumber getTelefonNumber() {
        return this.telefonNumber;
    }
	
	public void setTelefonNumber(TelefonNumber telefonNumber) {
        this.telefonNumber=telefonNumber;
    }
	
	public Date getLastOrderDate() {
        return this.lastOrderDate;
    }
	
	public void setLastOrderDate(Date lastOrderDate) {
        this.lastOrderDate=lastOrderDate;
    }
	
	public CreditCardInfo getCcInfo() {
        return this.ccInfo;
    }
	
	public void setCcInfo(CreditCardInfo ccInfo) {
        this.ccInfo=ccInfo;
    }
	
	public String getInvoiceAddressOid() {
        return this.invoiceAddressOid;
    }
	
	public void setInvoiceAddressOid(String invoiceAddressOid) {
        this.invoiceAddressOid=invoiceAddressOid;
    }
	
	public String getDeliveryAddressOid() {
        return this.deliveryAddressOid;
    }
	
	public void setDeliveryAddressOid(String deliveryAddressOid) {
        this.deliveryAddressOid=deliveryAddressOid;
    }
	
    public void mapFrom(Object sourceObject) {
    	if (sourceObject instanceof PrivateCustomer) {
    		PrivateCustomer privateCustomer = (PrivateCustomer) sourceObject;
    		internalMapFromPrivateCustomer(privateCustomer);	
    		if (privateCustomer.getInvoiceAddress()!=null) {
    			setInvoiceAddressOid(privateCustomer.getInvoiceAddress().getOid());
    		}
    		if (privateCustomer.getDeliveryAddress()!=null) {
    			setDeliveryAddressOid(privateCustomer.getDeliveryAddress().getOid());
    		}
    	} 
    	else if (sourceObject instanceof Address) {
    		Address address = (Address) sourceObject;
    		internalMapFromAddress(address);	
    	} 
    	else if (sourceObject != null) {
			throw new IllegalArgumentException("mapping from object '"+sourceObject+"' is not supported");
		}
	}
	
	public <T> T mapTo(Class<T> target) {
		if (PrivateCustomerView.class.equals(target)) { 
			PrivateCustomerView privateCustomerView = new PrivateCustomerView();
			internalMapToPrivateCustomerView(privateCustomerView);		
			return target.cast(privateCustomerView);
		}
		else if (PrivateCustomer.class.equals(target)) {
    		return target.cast(internalMapToPrivateCustomer(target));
    	}
		else if (Address.class.equals(target)) {
    		return target.cast(internalMapToAddress(target));
    	}
    	else { 
    		throw new IllegalArgumentException("mapping to class '"+target+"' is not supported");
    	}
    }
	
    public void mapTo(Object targetObject) {
    	if (targetObject instanceof PrivateCustomerView) { 
			internalMapToPrivateCustomerView(((PrivateCustomerView)targetObject));		
		}
    	else if (targetObject instanceof PrivateCustomer) {
    		internalMapToPrivateCustomer(((PrivateCustomer)targetObject));	
    	} 
    	else if (targetObject instanceof Address) {
    		internalMapToAddress(((Address)targetObject));	
    	} 
    	else if (targetObject != null) { 
			throw new IllegalArgumentException("mapping to object '"+targetObject+"' is not supported");
		}
	}
    
    protected void internalMapToPrivateCustomerView(PrivateCustomerView privateCustomerView) {
		privateCustomerView.setOid(getOid());
		privateCustomerView.setVersion(getVersion());
		privateCustomerView.setFirstName(getFirstName());
		privateCustomerView.setLastName(getLastName());
		privateCustomerView.setGender(getGender());
		privateCustomerView.setEmailAddress(getEmailAddress());
		privateCustomerView.setBirthDate(getBirthDate());
		privateCustomerView.setTelefonNumber(getTelefonNumber());
		privateCustomerView.setCcInfo(getCcInfo());
		privateCustomerView.setInvoiceAddressOid(getInvoiceAddressOid());
		privateCustomerView.setDeliveryAddressOid(getDeliveryAddressOid());
    }
    
    protected PrivateCustomer internalMapToPrivateCustomer(Class<?> target) {
    	EntityFactory<PrivateCustomer> entityFactory = (EntityFactory<PrivateCustomer>) 
    		MapperContextHolder.getEntityFactoryRegistry().getEntityFactory(PrivateCustomer.class);
    	PrivateCustomer privateCustomer = (PrivateCustomer) 
    		entityFactory.createEntity(null);
    	internalMapToPrivateCustomer(privateCustomer);	
    	return privateCustomer;
    }
    
    protected void internalMapToPrivateCustomer(PrivateCustomer privateCustomer) {
    	if (!MapperContextHolder.getContext().containsKey(this)) {
	    	MapperContextHolder.getContext().put(this, privateCustomer);
			if (getOid() != null) {
				privateCustomer.setOid(getOid());
			}
			privateCustomer.setVersion(getVersion());
			privateCustomer.setFirstName(getFirstName());
			privateCustomer.setLastName(getLastName());
			privateCustomer.setGender(getGender());
			privateCustomer.setEmailAddress(getEmailAddress());
			privateCustomer.setBirthDate(getBirthDate());
			privateCustomer.setTelefonNumber(getTelefonNumber());
			privateCustomer.setCcInfo(getCcInfo());
	    }
	}
	
    protected Address internalMapToAddress(Class<?> target) {
    	EntityFactory<Address> entityFactory = (EntityFactory<Address>) 
    		MapperContextHolder.getEntityFactoryRegistry().getEntityFactory(Address.class);
    	Address address = (Address) 
    		entityFactory.createEntity(null);
    	internalMapToAddress(address);	
    	return address;
    }
    
    protected void internalMapToAddress(Address address) {
    	if (!MapperContextHolder.getContext().containsKey(this)) {
	    	MapperContextHolder.getContext().put(this, address);
			if (getInvoiceAddressOid() != null  && isContext("invoiceAddress")) {
				address.setOid(getInvoiceAddressOid());
			}
			if (getDeliveryAddressOid() != null  && isContext("deliveryAddress")) {
				address.setOid(getDeliveryAddressOid());
			}
	    }
	}
	
	protected boolean isContext(String contextName) {
		return contextName.equals(MapperContextHolder.getContext().get("context"));
	}
	
	protected void internalMapFromPrivateCustomer(PrivateCustomer privateCustomer) {
		if (!MapperContextHolder.getContext().containsKey(privateCustomer)) {
	    	MapperContextHolder.getContext().put(privateCustomer, this);			
			setOid(privateCustomer.getOid());
			setVersion(privateCustomer.getVersion());
			setFirstName(privateCustomer.getFirstName());
			setLastName(privateCustomer.getLastName());
			setGender(privateCustomer.getGender());
			setEmailAddress(privateCustomer.getEmailAddress());
			setBirthDate(privateCustomer.getBirthDate());
			setTelefonNumber(privateCustomer.getTelefonNumber());
			setCcInfo(privateCustomer.getCcInfo());
		}
	}
	
	protected void internalMapFromAddress(Address address) {
		if (!MapperContextHolder.getContext().containsKey(address)) {
	    	MapperContextHolder.getContext().put(address, this);			
			setInvoiceAddressOid(address.getOid());
			setDeliveryAddressOid(address.getOid());
		}
	}
    
    @Override
    public String toString() {
    	return new StringBuilder("PrivateCustomerView [")
        	.append("oid=").append(getOid()).append(",")
        	.append("version=").append(getVersion()).append(",")
        	.append("firstName=").append(getFirstName()).append(",")
        	.append("lastName=").append(getLastName()).append(",")
        	.append("gender=").append(getGender()).append(",")
        	.append("emailAddress=").append(getEmailAddress()).append(",")
        	.append("birthDate=").append(getBirthDate()).append(",")
        	.append("telefonNumber=").append(getTelefonNumber()).append(",")
        	.append("lastOrderDate=").append(getLastOrderDate()).append(",")
        	.append("invoiceAddressOid=").append(getInvoiceAddressOid()).append(",")
        	.append("deliveryAddressOid=").append(getDeliveryAddressOid())
        	.append("]")
            .toString();
    }
}
