package org.openxma.dsl.reference.dto;

import java.io.Serializable;
import org.openxma.dsl.platform.dao.EntityFactory;
import org.openxma.dsl.platform.service.MapperContextHolder;
import java.util.Date;
import org.openxma.dsl.platform.service.EntityMapperSupport;
import org.openxma.dsl.reference.model.RoleGroup;

public abstract class RoleGroupViewGen implements Serializable,EntityMapperSupport {
	private static final long serialVersionUID = 348638105;
	protected String oid;
	protected Date version;
	protected String name;
	
	public String getOid() {
        return this.oid;
    }
	
	public void setOid(String oid) {
        this.oid=oid;
    }
	
	public Date getVersion() {
        return this.version;
    }
	
	public void setVersion(Date version) {
        this.version=version;
    }
	
	public String getName() {
        return this.name;
    }
	
	public void setName(String name) {
        this.name=name;
    }
	
    public void mapFrom(Object sourceObject) {
    	if (sourceObject instanceof RoleGroup) {
    		RoleGroup roleGroup = (RoleGroup) sourceObject;
    		internalMapFromRoleGroup(roleGroup);	
    	} 
    	else if (sourceObject != null) {
			throw new IllegalArgumentException("mapping from object '"+sourceObject+"' is not supported");
		}
	}
	
	public <T> T mapTo(Class<T> target) {
		if (RoleGroupView.class.equals(target)) { 
			RoleGroupView roleGroupView = new RoleGroupView();
			internalMapToRoleGroupView(roleGroupView);		
			return target.cast(roleGroupView);
		}
		else if (RoleGroup.class.equals(target)) {
    		return target.cast(internalMapToRoleGroup(target));
    	}
    	else { 
    		throw new IllegalArgumentException("mapping to class '"+target+"' is not supported");
    	}
    }
	
    public void mapTo(Object targetObject) {
    	if (targetObject instanceof RoleGroupView) { 
			internalMapToRoleGroupView(((RoleGroupView)targetObject));		
		}
    	else if (targetObject instanceof RoleGroup) {
    		internalMapToRoleGroup(((RoleGroup)targetObject));	
    	} 
    	else if (targetObject != null) { 
			throw new IllegalArgumentException("mapping to object '"+targetObject+"' is not supported");
		}
	}
    
    protected void internalMapToRoleGroupView(RoleGroupView roleGroupView) {
		roleGroupView.setOid(getOid());
		roleGroupView.setVersion(getVersion());
		roleGroupView.setName(getName());
    }
    
    protected RoleGroup internalMapToRoleGroup(Class<?> target) {
    	EntityFactory<RoleGroup> entityFactory = (EntityFactory<RoleGroup>) 
    		MapperContextHolder.getEntityFactoryRegistry().getEntityFactory(RoleGroup.class);
    	RoleGroup roleGroup = (RoleGroup) 
    		entityFactory.createEntity(null);
    	internalMapToRoleGroup(roleGroup);	
    	return roleGroup;
    }
    
    protected void internalMapToRoleGroup(RoleGroup roleGroup) {
    	if (!MapperContextHolder.getContext().containsKey(this)) {
	    	MapperContextHolder.getContext().put(this, roleGroup);
			if (getOid() != null) {
				roleGroup.setOid(getOid());
			}
			roleGroup.setVersion(getVersion());
			roleGroup.setName(getName());
	    }
	}
	
	protected void internalMapFromRoleGroup(RoleGroup roleGroup) {
		if (!MapperContextHolder.getContext().containsKey(roleGroup)) {
	    	MapperContextHolder.getContext().put(roleGroup, this);			
			setOid(roleGroup.getOid());
			setVersion(roleGroup.getVersion());
			setName(roleGroup.getName());
		}
	}
    
    @Override
    public String toString() {
    	return new StringBuilder("RoleGroupView [")
        	.append("oid=").append(getOid()).append(",")
        	.append("version=").append(getVersion()).append(",")
        	.append("name=").append(getName())
        	.append("]")
            .toString();
    }
}
