package org.openxma.dsl.reference.dto;

import java.io.Serializable;
import org.openxma.dsl.platform.dao.EntityFactory;
import org.openxma.dsl.platform.service.MapperContextHolder;
import java.util.Date;
import org.openxma.dsl.platform.service.EntityMapperSupport;
import org.openxma.dsl.reference.model.Role;

public abstract class RoleViewGen implements Serializable,EntityMapperSupport {
	private static final long serialVersionUID = 348638105;
	protected String oid;
	protected Date version;
	protected String name;
	
	public String getOid() {
        return this.oid;
    }
	
	public void setOid(String oid) {
        this.oid=oid;
    }
	
	public Date getVersion() {
        return this.version;
    }
	
	public void setVersion(Date version) {
        this.version=version;
    }
	
	public String getName() {
        return this.name;
    }
	
	public void setName(String name) {
        this.name=name;
    }
	
    public void mapFrom(Object sourceObject) {
    	if (sourceObject instanceof Role) {
    		Role role = (Role) sourceObject;
    		internalMapFromRole(role);	
    	} 
    	else if (sourceObject != null) {
			throw new IllegalArgumentException("mapping from object '"+sourceObject+"' is not supported");
		}
	}
	
	public <T> T mapTo(Class<T> target) {
		if (RoleView.class.equals(target)) { 
			RoleView roleView = new RoleView();
			internalMapToRoleView(roleView);		
			return target.cast(roleView);
		}
		else if (Role.class.equals(target)) {
    		return target.cast(internalMapToRole(target));
    	}
    	else { 
    		throw new IllegalArgumentException("mapping to class '"+target+"' is not supported");
    	}
    }
	
    public void mapTo(Object targetObject) {
    	if (targetObject instanceof RoleView) { 
			internalMapToRoleView(((RoleView)targetObject));		
		}
    	else if (targetObject instanceof Role) {
    		internalMapToRole(((Role)targetObject));	
    	} 
    	else if (targetObject != null) { 
			throw new IllegalArgumentException("mapping to object '"+targetObject+"' is not supported");
		}
	}
    
    protected void internalMapToRoleView(RoleView roleView) {
		roleView.setOid(getOid());
		roleView.setVersion(getVersion());
		roleView.setName(getName());
    }
    
    protected Role internalMapToRole(Class<?> target) {
    	EntityFactory<Role> entityFactory = (EntityFactory<Role>) 
    		MapperContextHolder.getEntityFactoryRegistry().getEntityFactory(Role.class);
    	Role role = (Role) 
    		entityFactory.createEntity(null);
    	internalMapToRole(role);	
    	return role;
    }
    
    protected void internalMapToRole(Role role) {
    	if (!MapperContextHolder.getContext().containsKey(this)) {
	    	MapperContextHolder.getContext().put(this, role);
			if (getOid() != null) {
				role.setOid(getOid());
			}
			role.setVersion(getVersion());
			role.setName(getName());
	    }
	}
	
	protected void internalMapFromRole(Role role) {
		if (!MapperContextHolder.getContext().containsKey(role)) {
	    	MapperContextHolder.getContext().put(role, this);			
			setOid(role.getOid());
			setVersion(role.getVersion());
			setName(role.getName());
		}
	}
    
    @Override
    public String toString() {
    	return new StringBuilder("RoleView [")
        	.append("oid=").append(getOid()).append(",")
        	.append("version=").append(getVersion()).append(",")
        	.append("name=").append(getName())
        	.append("]")
            .toString();
    }
}
