package org.openxma.dsl.reference.dto;

import java.io.Serializable;
import org.openxma.dsl.platform.dao.EntityFactory;
import org.openxma.dsl.platform.service.MapperContextHolder;
import java.util.Date;
import org.openxma.dsl.platform.service.EntityMapperSupport;
import org.openxma.dsl.reference.model.SingleRole;

public abstract class SingleRoleViewGen implements Serializable,EntityMapperSupport {
	private static final long serialVersionUID = 129511682;
	protected String oid;
	protected Date version;
	protected String name;
	protected String roleValue;
	
	public String getOid() {
        return this.oid;
    }
	
	public void setOid(String oid) {
        this.oid=oid;
    }
	
	public Date getVersion() {
        return this.version;
    }
	
	public void setVersion(Date version) {
        this.version=version;
    }
	
	public String getName() {
        return this.name;
    }
	
	public void setName(String name) {
        this.name=name;
    }
	
	public String getRoleValue() {
        return this.roleValue;
    }
	
	public void setRoleValue(String roleValue) {
        this.roleValue=roleValue;
    }
	
    public void mapFrom(Object sourceObject) {
    	if (sourceObject instanceof SingleRole) {
    		SingleRole singleRole = (SingleRole) sourceObject;
    		internalMapFromSingleRole(singleRole);	
    	} 
    	else if (sourceObject != null) {
			throw new IllegalArgumentException("mapping from object '"+sourceObject+"' is not supported");
		}
	}
	
	public <T> T mapTo(Class<T> target) {
		if (SingleRoleView.class.equals(target)) { 
			SingleRoleView singleRoleView = new SingleRoleView();
			internalMapToSingleRoleView(singleRoleView);		
			return target.cast(singleRoleView);
		}
		else if (SingleRole.class.equals(target)) {
    		return target.cast(internalMapToSingleRole(target));
    	}
    	else { 
    		throw new IllegalArgumentException("mapping to class '"+target+"' is not supported");
    	}
    }
	
    public void mapTo(Object targetObject) {
    	if (targetObject instanceof SingleRoleView) { 
			internalMapToSingleRoleView(((SingleRoleView)targetObject));		
		}
    	else if (targetObject instanceof SingleRole) {
    		internalMapToSingleRole(((SingleRole)targetObject));	
    	} 
    	else if (targetObject != null) { 
			throw new IllegalArgumentException("mapping to object '"+targetObject+"' is not supported");
		}
	}
    
    protected void internalMapToSingleRoleView(SingleRoleView singleRoleView) {
		singleRoleView.setOid(getOid());
		singleRoleView.setVersion(getVersion());
		singleRoleView.setName(getName());
		singleRoleView.setRoleValue(getRoleValue());
    }
    
    protected SingleRole internalMapToSingleRole(Class<?> target) {
    	EntityFactory<SingleRole> entityFactory = (EntityFactory<SingleRole>) 
    		MapperContextHolder.getEntityFactoryRegistry().getEntityFactory(SingleRole.class);
    	SingleRole singleRole = (SingleRole) 
    		entityFactory.createEntity(null);
    	internalMapToSingleRole(singleRole);	
    	return singleRole;
    }
    
    protected void internalMapToSingleRole(SingleRole singleRole) {
    	if (!MapperContextHolder.getContext().containsKey(this)) {
	    	MapperContextHolder.getContext().put(this, singleRole);
			if (getOid() != null) {
				singleRole.setOid(getOid());
			}
			singleRole.setVersion(getVersion());
			singleRole.setName(getName());
			singleRole.setRoleValue(getRoleValue());
	    }
	}
	
	protected void internalMapFromSingleRole(SingleRole singleRole) {
		if (!MapperContextHolder.getContext().containsKey(singleRole)) {
	    	MapperContextHolder.getContext().put(singleRole, this);			
			setOid(singleRole.getOid());
			setVersion(singleRole.getVersion());
			setName(singleRole.getName());
			setRoleValue(singleRole.getRoleValue());
		}
	}
    
    @Override
    public String toString() {
    	return new StringBuilder("SingleRoleView [")
        	.append("oid=").append(getOid()).append(",")
        	.append("version=").append(getVersion()).append(",")
        	.append("name=").append(getName()).append(",")
        	.append("roleValue=").append(getRoleValue())
        	.append("]")
            .toString();
    }
}
