package org.openxma.dsl.reference.dto;

import java.io.Serializable;
import org.openxma.dsl.platform.dao.EntityFactory;
import org.openxma.dsl.platform.service.MapperContextHolder;
import org.openxma.dsl.platform.service.EntityMapperSupport;
import org.openxma.dsl.reference.model.Supplier;

public abstract class SupplierNameViewGen implements Serializable,EntityMapperSupport {
	private static final long serialVersionUID = 3373707;
	protected String name;
	
	public String getName() {
        return this.name;
    }
	
	public void setName(String name) {
        this.name=name;
    }
	
    public void mapFrom(Object sourceObject) {
    	if (sourceObject instanceof Supplier) {
    		Supplier supplier = (Supplier) sourceObject;
    		internalMapFromSupplier(supplier);	
    	} 
    	else if (sourceObject != null) {
			throw new IllegalArgumentException("mapping from object '"+sourceObject+"' is not supported");
		}
	}
	
	public <T> T mapTo(Class<T> target) {
		if (SupplierNameView.class.equals(target)) { 
			SupplierNameView supplierNameView = new SupplierNameView();
			internalMapToSupplierNameView(supplierNameView);		
			return target.cast(supplierNameView);
		}
		else if (Supplier.class.equals(target)) {
    		return target.cast(internalMapToSupplier(target));
    	}
    	else { 
    		throw new IllegalArgumentException("mapping to class '"+target+"' is not supported");
    	}
    }
	
    public void mapTo(Object targetObject) {
    	if (targetObject instanceof SupplierNameView) { 
			internalMapToSupplierNameView(((SupplierNameView)targetObject));		
		}
    	else if (targetObject instanceof Supplier) {
    		internalMapToSupplier(((Supplier)targetObject));	
    	} 
    	else if (targetObject != null) { 
			throw new IllegalArgumentException("mapping to object '"+targetObject+"' is not supported");
		}
	}
    
    protected void internalMapToSupplierNameView(SupplierNameView supplierNameView) {
		supplierNameView.setName(getName());
    }
    
    protected Supplier internalMapToSupplier(Class<?> target) {
    	EntityFactory<Supplier> entityFactory = (EntityFactory<Supplier>) 
    		MapperContextHolder.getEntityFactoryRegistry().getEntityFactory(Supplier.class);
    	Supplier supplier = (Supplier) 
    		entityFactory.createEntity(null);
    	internalMapToSupplier(supplier);	
    	return supplier;
    }
    
    protected void internalMapToSupplier(Supplier supplier) {
    	if (!MapperContextHolder.getContext().containsKey(this)) {
	    	MapperContextHolder.getContext().put(this, supplier);
			supplier.setCompanyName(getName());
	    }
	}
	
	protected void internalMapFromSupplier(Supplier supplier) {
		if (!MapperContextHolder.getContext().containsKey(supplier)) {
	    	MapperContextHolder.getContext().put(supplier, this);			
			setName(supplier.getCompanyName());
		}
	}
    
    @Override
    public String toString() {
    	return new StringBuilder("SupplierNameView [")
        	.append("name=").append(getName())
        	.append("]")
            .toString();
    }
}
