package org.openxma.dsl.reference.dto;

import java.io.Serializable;
import org.openxma.dsl.platform.dao.EntityFactory;
import org.openxma.dsl.platform.service.MapperContextHolder;
import java.util.Date;
import org.openxma.dsl.platform.service.EntityMapperSupport;
import org.openxma.dsl.reference.SupplierAddress;
import org.openxma.dsl.reference.base.ContactInfo;
import org.openxma.dsl.reference.model.Supplier;

public abstract class SupplierViewGen implements Serializable,EntityMapperSupport {
	private static final long serialVersionUID = 1987816046;
	protected String oid;
	protected Date version;
	protected String companyName;
	protected SupplierAddress address = new SupplierAddress();
	protected ContactInfo contact = new ContactInfo();
	
	public String getOid() {
        return this.oid;
    }
	
	public void setOid(String oid) {
        this.oid=oid;
    }
	
	public Date getVersion() {
        return this.version;
    }
	
	public void setVersion(Date version) {
        this.version=version;
    }
	
	public String getCompanyName() {
        return this.companyName;
    }
	
	public void setCompanyName(String companyName) {
        this.companyName=companyName;
    }
	
	public SupplierAddress getAddress() {
        return this.address;
    }
	
	public void setAddress(SupplierAddress address) {
        this.address=address;
    }
	
	public ContactInfo getContact() {
        return this.contact;
    }
	
	public void setContact(ContactInfo contact) {
        this.contact=contact;
    }
	
    public void mapFrom(Object sourceObject) {
    	if (sourceObject instanceof Supplier) {
    		Supplier supplier = (Supplier) sourceObject;
    		internalMapFromSupplier(supplier);	
    	} 
    	else if (sourceObject != null) {
			throw new IllegalArgumentException("mapping from object '"+sourceObject+"' is not supported");
		}
	}
	
	public <T> T mapTo(Class<T> target) {
		if (SupplierView.class.equals(target)) { 
			SupplierView supplierView = new SupplierView();
			internalMapToSupplierView(supplierView);		
			return target.cast(supplierView);
		}
		else if (Supplier.class.equals(target)) {
    		return target.cast(internalMapToSupplier(target));
    	}
    	else { 
    		throw new IllegalArgumentException("mapping to class '"+target+"' is not supported");
    	}
    }
	
    public void mapTo(Object targetObject) {
    	if (targetObject instanceof SupplierView) { 
			internalMapToSupplierView(((SupplierView)targetObject));		
		}
    	else if (targetObject instanceof Supplier) {
    		internalMapToSupplier(((Supplier)targetObject));	
    	} 
    	else if (targetObject != null) { 
			throw new IllegalArgumentException("mapping to object '"+targetObject+"' is not supported");
		}
	}
    
    protected void internalMapToSupplierView(SupplierView supplierView) {
		supplierView.setOid(getOid());
		supplierView.setVersion(getVersion());
		supplierView.setCompanyName(getCompanyName());
		supplierView.setAddress(getAddress());
		supplierView.setContact(getContact());
    }
    
    protected Supplier internalMapToSupplier(Class<?> target) {
    	EntityFactory<Supplier> entityFactory = (EntityFactory<Supplier>) 
    		MapperContextHolder.getEntityFactoryRegistry().getEntityFactory(Supplier.class);
    	Supplier supplier = (Supplier) 
    		entityFactory.createEntity(null);
    	internalMapToSupplier(supplier);	
    	return supplier;
    }
    
    protected void internalMapToSupplier(Supplier supplier) {
    	if (!MapperContextHolder.getContext().containsKey(this)) {
	    	MapperContextHolder.getContext().put(this, supplier);
			if (getOid() != null) {
				supplier.setOid(getOid());
			}
			supplier.setVersion(getVersion());
			supplier.setCompanyName(getCompanyName());
			supplier.setAddress(getAddress());
			supplier.setContact(getContact());
	    }
	}
	
	protected void internalMapFromSupplier(Supplier supplier) {
		if (!MapperContextHolder.getContext().containsKey(supplier)) {
	    	MapperContextHolder.getContext().put(supplier, this);			
			setOid(supplier.getOid());
			setVersion(supplier.getVersion());
			setCompanyName(supplier.getCompanyName());
			setAddress(supplier.getAddress());
			setContact(supplier.getContact());
		}
	}
    
    @Override
    public String toString() {
    	return new StringBuilder("SupplierView [")
        	.append("oid=").append(getOid()).append(",")
        	.append("version=").append(getVersion()).append(",")
        	.append("companyName=").append(getCompanyName())
        	.append("]")
            .toString();
    }
}
