package org.openxma.dsl.reference.dto;

import java.io.Serializable;
import org.openxma.dsl.platform.dao.EntityFactory;
import org.openxma.dsl.platform.service.MapperContextHolder;
import org.openxma.dsl.platform.service.EntityMapperSupport;
import org.openxma.dsl.reference.model.TestEntity;

public abstract class TestEntityViewGen implements Serializable,EntityMapperSupport {
	private static final long serialVersionUID = -4042052;
	protected String testString2;
	protected Integer testInteger;
	protected Long testLong;
	protected Boolean testBoolean;
	protected Double testDouble;
	protected Float testFloat;
	protected String testString1;
	
	public String getTestString2() {
        return this.testString2;
    }
	
	public void setTestString2(String testString2) {
        this.testString2=testString2;
    }
	
	public Integer getTestInteger() {
        return this.testInteger;
    }
	
	public void setTestInteger(Integer testInteger) {
        this.testInteger=testInteger;
    }
	
	public Long getTestLong() {
        return this.testLong;
    }
	
	public void setTestLong(Long testLong) {
        this.testLong=testLong;
    }
	
	public Boolean getTestBoolean() {
        return this.testBoolean;
    }
	
	public void setTestBoolean(Boolean testBoolean) {
        this.testBoolean=testBoolean;
    }
	
	public Double getTestDouble() {
        return this.testDouble;
    }
	
	public void setTestDouble(Double testDouble) {
        this.testDouble=testDouble;
    }
	
	public Float getTestFloat() {
        return this.testFloat;
    }
	
	public void setTestFloat(Float testFloat) {
        this.testFloat=testFloat;
    }
	
	public String getTestString1() {
        return this.testString1;
    }
	
	public void setTestString1(String testString1) {
        this.testString1=testString1;
    }
	
    public void mapFrom(Object sourceObject) {
    	if (sourceObject instanceof TestEntity) {
    		TestEntity testEntity = (TestEntity) sourceObject;
    		internalMapFromTestEntity(testEntity);	
    	} 
    	else if (sourceObject != null) {
			throw new IllegalArgumentException("mapping from object '"+sourceObject+"' is not supported");
		}
	}
	
	public <T> T mapTo(Class<T> target) {
		if (TestEntityView.class.equals(target)) { 
			TestEntityView testEntityView = new TestEntityView();
			internalMapToTestEntityView(testEntityView);		
			return target.cast(testEntityView);
		}
		else if (TestEntity.class.equals(target)) {
    		return target.cast(internalMapToTestEntity(target));
    	}
    	else { 
    		throw new IllegalArgumentException("mapping to class '"+target+"' is not supported");
    	}
    }
	
    public void mapTo(Object targetObject) {
    	if (targetObject instanceof TestEntityView) { 
			internalMapToTestEntityView(((TestEntityView)targetObject));		
		}
    	else if (targetObject instanceof TestEntity) {
    		internalMapToTestEntity(((TestEntity)targetObject));	
    	} 
    	else if (targetObject != null) { 
			throw new IllegalArgumentException("mapping to object '"+targetObject+"' is not supported");
		}
	}
    
    protected void internalMapToTestEntityView(TestEntityView testEntityView) {
		testEntityView.setTestString2(getTestString2());
		testEntityView.setTestInteger(getTestInteger());
		testEntityView.setTestLong(getTestLong());
		testEntityView.setTestBoolean(getTestBoolean());
		testEntityView.setTestDouble(getTestDouble());
		testEntityView.setTestFloat(getTestFloat());
		testEntityView.setTestString1(getTestString1());
    }
    
    protected TestEntity internalMapToTestEntity(Class<?> target) {
    	EntityFactory<TestEntity> entityFactory = (EntityFactory<TestEntity>) 
    		MapperContextHolder.getEntityFactoryRegistry().getEntityFactory(TestEntity.class);
    	TestEntity testEntity = (TestEntity) 
    		entityFactory.createEntity(null);
    	internalMapToTestEntity(testEntity);	
    	return testEntity;
    }
    
    protected void internalMapToTestEntity(TestEntity testEntity) {
    	if (!MapperContextHolder.getContext().containsKey(this)) {
	    	MapperContextHolder.getContext().put(this, testEntity);
			testEntity.setTestString2(getTestString2());
			testEntity.setTestInteger(getTestInteger());
			testEntity.setTestLong(getTestLong());
			testEntity.setTestBoolean(getTestBoolean());
			testEntity.setTestDouble(getTestDouble());
			testEntity.setTestFloat(getTestFloat());
			testEntity.setTestString1(getTestString1());
	    }
	}
	
	protected void internalMapFromTestEntity(TestEntity testEntity) {
		if (!MapperContextHolder.getContext().containsKey(testEntity)) {
	    	MapperContextHolder.getContext().put(testEntity, this);			
			setTestString2(testEntity.getTestString2());
			setTestInteger(testEntity.getTestInteger());
			setTestLong(testEntity.getTestLong());
			setTestBoolean(testEntity.getTestBoolean());
			setTestDouble(testEntity.getTestDouble());
			setTestFloat(testEntity.getTestFloat());
			setTestString1(testEntity.getTestString1());
		}
	}
    
    @Override
    public String toString() {
    	return new StringBuilder("TestEntityView [")
        	.append("testString2=").append(getTestString2()).append(",")
        	.append("testInteger=").append(getTestInteger()).append(",")
        	.append("testLong=").append(getTestLong()).append(",")
        	.append("testBoolean=").append(getTestBoolean()).append(",")
        	.append("testDouble=").append(getTestDouble()).append(",")
        	.append("testFloat=").append(getTestFloat()).append(",")
        	.append("testString1=").append(getTestString1())
        	.append("]")
            .toString();
    }
}
