package org.openxma.dsl.reference.dto;

import java.io.Serializable;
import org.openxma.dsl.platform.dao.EntityFactory;
import org.openxma.dsl.platform.service.MapperContextHolder;
import java.util.Date;
import org.openxma.dsl.platform.service.EntityMapperSupport;
import org.openxma.dsl.platform.valueobject.ValueObjectByteArray;
import org.openxma.dsl.reference.model.VOData;
import org.openxma.dsl.reference.types.valueobject.VOBigDecimal;
import org.openxma.dsl.reference.types.valueobject.VOBoolean;
import org.openxma.dsl.reference.types.valueobject.VOByteArray;
import org.openxma.dsl.reference.types.valueobject.VODate;
import org.openxma.dsl.reference.types.valueobject.VODouble;
import org.openxma.dsl.reference.types.valueobject.VOFloat;
import org.openxma.dsl.reference.types.valueobject.VOI18Enumeration;
import org.openxma.dsl.reference.types.valueobject.VOInteger;
import org.openxma.dsl.reference.types.valueobject.VOLong;
import org.openxma.dsl.reference.types.valueobject.VOString;
import org.openxma.dsl.reference.types.valueobject.VOTimestamp;
import org.openxma.dsl.reference.types.valueobject.VOXml;

public abstract class VODataViewGen implements Serializable,EntityMapperSupport {
	private static final long serialVersionUID = -1523593876;
	protected String oid;
	protected Date version;
	protected VOBigDecimal pVOBigDecimal;
	protected VODate pVODate;
	protected VOTimestamp pVOTimestamp;
	protected VODouble pVODouble;
	protected VOFloat pVOFloat;
	protected VOInteger pVOInteger;
	protected VOLong pVOLong;
	protected VOString pVOString;
	protected VOBoolean pVOBoolean;
	protected VOI18Enumeration pVOI18Enumeration;
	protected VOByteArray pVOByteArray;
	protected VOXml pVOXml;
	protected ValueObjectByteArray pVOXml2;
	
	public String getOid() {
        return this.oid;
    }
	
	public void setOid(String oid) {
        this.oid=oid;
    }
	
	public Date getVersion() {
        return this.version;
    }
	
	public void setVersion(Date version) {
        this.version=version;
    }
	
	public VOBigDecimal getPVOBigDecimal() {
        return this.pVOBigDecimal;
    }
	
	public void setPVOBigDecimal(VOBigDecimal pVOBigDecimal) {
        this.pVOBigDecimal=pVOBigDecimal;
    }
	
	public VODate getPVODate() {
        return this.pVODate;
    }
	
	public void setPVODate(VODate pVODate) {
        this.pVODate=pVODate;
    }
	
	public VOTimestamp getPVOTimestamp() {
        return this.pVOTimestamp;
    }
	
	public void setPVOTimestamp(VOTimestamp pVOTimestamp) {
        this.pVOTimestamp=pVOTimestamp;
    }
	
	public VODouble getPVODouble() {
        return this.pVODouble;
    }
	
	public void setPVODouble(VODouble pVODouble) {
        this.pVODouble=pVODouble;
    }
	
	public VOFloat getPVOFloat() {
        return this.pVOFloat;
    }
	
	public void setPVOFloat(VOFloat pVOFloat) {
        this.pVOFloat=pVOFloat;
    }
	
	public VOInteger getPVOInteger() {
        return this.pVOInteger;
    }
	
	public void setPVOInteger(VOInteger pVOInteger) {
        this.pVOInteger=pVOInteger;
    }
	
	public VOLong getPVOLong() {
        return this.pVOLong;
    }
	
	public void setPVOLong(VOLong pVOLong) {
        this.pVOLong=pVOLong;
    }
	
	public VOString getPVOString() {
        return this.pVOString;
    }
	
	public void setPVOString(VOString pVOString) {
        this.pVOString=pVOString;
    }
	
	public VOBoolean getPVOBoolean() {
        return this.pVOBoolean;
    }
	
	public void setPVOBoolean(VOBoolean pVOBoolean) {
        this.pVOBoolean=pVOBoolean;
    }
	
	public VOI18Enumeration getPVOI18Enumeration() {
        return this.pVOI18Enumeration;
    }
	
	public void setPVOI18Enumeration(VOI18Enumeration pVOI18Enumeration) {
        this.pVOI18Enumeration=pVOI18Enumeration;
    }
	
	public VOByteArray getPVOByteArray() {
        return this.pVOByteArray;
    }
	
	public void setPVOByteArray(VOByteArray pVOByteArray) {
        this.pVOByteArray=pVOByteArray;
    }
	
	public VOXml getPVOXml() {
        return this.pVOXml;
    }
	
	public void setPVOXml(VOXml pVOXml) {
        this.pVOXml=pVOXml;
    }
	
	public ValueObjectByteArray getPVOXml2() {
        return this.pVOXml2;
    }
	
	public void setPVOXml2(ValueObjectByteArray pVOXml2) {
        this.pVOXml2=pVOXml2;
    }
	
    public void mapFrom(Object sourceObject) {
    	if (sourceObject instanceof VOData) {
    		VOData vOData = (VOData) sourceObject;
    		internalMapFromVOData(vOData);	
    	} 
    	else if (sourceObject != null) {
			throw new IllegalArgumentException("mapping from object '"+sourceObject+"' is not supported");
		}
	}
	
	public <T> T mapTo(Class<T> target) {
		if (VODataView.class.equals(target)) { 
			VODataView vODataView = new VODataView();
			internalMapToVODataView(vODataView);		
			return target.cast(vODataView);
		}
		else if (VOData.class.equals(target)) {
    		return target.cast(internalMapToVOData(target));
    	}
    	else { 
    		throw new IllegalArgumentException("mapping to class '"+target+"' is not supported");
    	}
    }
	
    public void mapTo(Object targetObject) {
    	if (targetObject instanceof VODataView) { 
			internalMapToVODataView(((VODataView)targetObject));		
		}
    	else if (targetObject instanceof VOData) {
    		internalMapToVOData(((VOData)targetObject));	
    	} 
    	else if (targetObject != null) { 
			throw new IllegalArgumentException("mapping to object '"+targetObject+"' is not supported");
		}
	}
    
    protected void internalMapToVODataView(VODataView vODataView) {
		vODataView.setOid(getOid());
		vODataView.setVersion(getVersion());
		vODataView.setPVOBigDecimal(getPVOBigDecimal());
		vODataView.setPVODate(getPVODate());
		vODataView.setPVOTimestamp(getPVOTimestamp());
		vODataView.setPVODouble(getPVODouble());
		vODataView.setPVOFloat(getPVOFloat());
		vODataView.setPVOInteger(getPVOInteger());
		vODataView.setPVOLong(getPVOLong());
		vODataView.setPVOString(getPVOString());
		vODataView.setPVOBoolean(getPVOBoolean());
		vODataView.setPVOI18Enumeration(getPVOI18Enumeration());
		vODataView.setPVOByteArray(getPVOByteArray());
		vODataView.setPVOXml(getPVOXml());
		vODataView.setPVOXml2(getPVOXml2());
    }
    
    protected VOData internalMapToVOData(Class<?> target) {
    	EntityFactory<VOData> entityFactory = (EntityFactory<VOData>) 
    		MapperContextHolder.getEntityFactoryRegistry().getEntityFactory(VOData.class);
    	VOData vOData = (VOData) 
    		entityFactory.createEntity(null);
    	internalMapToVOData(vOData);	
    	return vOData;
    }
    
    protected void internalMapToVOData(VOData vOData) {
    	if (!MapperContextHolder.getContext().containsKey(this)) {
	    	MapperContextHolder.getContext().put(this, vOData);
			if (getOid() != null) {
				vOData.setOid(getOid());
			}
			vOData.setVersion(getVersion());
			vOData.setPVOBigDecimal(getPVOBigDecimal());
			vOData.setPVODate(getPVODate());
			vOData.setPVOTimestamp(getPVOTimestamp());
			vOData.setPVODouble(getPVODouble());
			vOData.setPVOFloat(getPVOFloat());
			vOData.setPVOInteger(getPVOInteger());
			vOData.setPVOLong(getPVOLong());
			vOData.setPVOString(getPVOString());
			vOData.setPVOBoolean(getPVOBoolean());
			vOData.setPVOI18Enumeration(getPVOI18Enumeration());
			vOData.setPVOByteArray(getPVOByteArray());
			vOData.setPVOXml(getPVOXml());
			vOData.setPVOXml2(getPVOXml2());
	    }
	}
	
	protected void internalMapFromVOData(VOData vOData) {
		if (!MapperContextHolder.getContext().containsKey(vOData)) {
	    	MapperContextHolder.getContext().put(vOData, this);			
			setOid(vOData.getOid());
			setVersion(vOData.getVersion());
			setPVOBigDecimal(vOData.getPVOBigDecimal());
			setPVODate(vOData.getPVODate());
			setPVOTimestamp(vOData.getPVOTimestamp());
			setPVODouble(vOData.getPVODouble());
			setPVOFloat(vOData.getPVOFloat());
			setPVOInteger(vOData.getPVOInteger());
			setPVOLong(vOData.getPVOLong());
			setPVOString(vOData.getPVOString());
			setPVOBoolean(vOData.getPVOBoolean());
			setPVOI18Enumeration(vOData.getPVOI18Enumeration());
			setPVOByteArray(vOData.getPVOByteArray());
			setPVOXml(vOData.getPVOXml());
			setPVOXml2(vOData.getPVOXml2());
		}
	}
    
    @Override
    public String toString() {
    	return new StringBuilder("VODataView [")
        	.append("oid=").append(getOid()).append(",")
        	.append("version=").append(getVersion()).append(",")
        	.append("pVOBigDecimal=").append(getPVOBigDecimal()).append(",")
        	.append("pVODate=").append(getPVODate()).append(",")
        	.append("pVOTimestamp=").append(getPVOTimestamp()).append(",")
        	.append("pVODouble=").append(getPVODouble()).append(",")
        	.append("pVOFloat=").append(getPVOFloat()).append(",")
        	.append("pVOInteger=").append(getPVOInteger()).append(",")
        	.append("pVOLong=").append(getPVOLong()).append(",")
        	.append("pVOString=").append(getPVOString()).append(",")
        	.append("pVOBoolean=").append(getPVOBoolean()).append(",")
        	.append("pVOI18Enumeration=").append(getPVOI18Enumeration()).append(",")
        	.append("pVOByteArray=").append(getPVOByteArray()).append(",")
        	.append("pVOXml=").append(getPVOXml()).append(",")
        	.append("pVOXml2=").append(getPVOXml2())
        	.append("]")
            .toString();
    }
}
