package org.openxma.dsl.reference.types.valueobject;

/**
 * Represents a custom DataType for <code>TelefonNumber</code>.
 */
public class TelefonNumber extends org.openxma.dsl.platform.valueobject.ValueObjectInteger {

    /**
     * Put the control and responsibility on the developer to determine the version of the
     * serialization class with which a serialized object is compatible.
     */
    private static final long serialVersionUID = 100L;

    /**
     * default ctor
     */
    public TelefonNumber(Integer pInteger) {
    	super(pInteger);
    }

    /**
     * Create a new instance of TelefonNumber or return null depending on input.
     */
    public static TelefonNumber newOrNull(Integer pInteger) {
        if (pInteger != null) {
            return new TelefonNumber(pInteger);
        }
        return null;
    }

    /**
     * Create a new instance of TelefonNumber or return null depending on input.
     */
    public static TelefonNumber newOrNull(String value) {
        if (value != null && value.length() > 0) {
            return new TelefonNumber(Integer.valueOf(value));
        }
        return null;
    }

}
