package org.openxma.dsl.reference.validation;

import org.openxma.dsl.platform.validation.Validators;
import org.springframework.validation.Errors;

import org.openxma.dsl.reference.model.OrderItem;
import org.springframework.validation.ValidationUtils;

public abstract class OrderItemGenValidator extends Validators {
	
	public boolean isItemNoRequired(OrderItem orderItem) {
		return Boolean.TRUE;
	}
	
	public boolean isQuantityRequired(OrderItem orderItem) {
		return Boolean.TRUE;
	}
	
	public boolean isOrderRequired(OrderItem orderItem) {
		return Boolean.TRUE;
	}
	
	public boolean isProductRequired(OrderItem orderItem) {
		return Boolean.TRUE;
	}
		
	@SuppressWarnings("unchecked")
	public boolean supports(Class clazz) {
		return OrderItem.class.isAssignableFrom(clazz);
	}
	
	public Errors validate(OrderItem orderItem) {
		Errors errors = createErrors(orderItem);
		validate(orderItem,errors);
		return errors;
	}

	public void validate(Object object, Errors errors) {
		OrderItem orderItem = (OrderItem) object;
		if (isItemNoRequired(orderItem)) {
			ValidationUtils.rejectIfEmpty(errors, "itemNo", "field.required");
		}
		if (isQuantityRequired(orderItem)) {
			ValidationUtils.rejectIfEmpty(errors, "quantity", "field.required");
		}
		if (isOrderRequired(orderItem)) {
			ValidationUtils.rejectIfEmpty(errors, "order", "field.required");
		}
		if (isProductRequired(orderItem)) {
			ValidationUtils.rejectIfEmpty(errors, "product", "field.required");
		}
	}
	
}
