package org.openxma.dsl.reference.validation;

import org.openxma.dsl.platform.validation.Validators;
import org.springframework.validation.Errors;

import org.openxma.dsl.reference.model.ProductImage;
import org.springframework.validation.ValidationUtils;

public abstract class ProductImageGenValidator extends Validators {
	
	public boolean isNameRequired(ProductImage productImage) {
		return Boolean.TRUE;
	}
	
	public boolean isFileNameRequired(ProductImage productImage) {
		return Boolean.TRUE;
	}
	
	public boolean isProductRequired(ProductImage productImage) {
		return Boolean.TRUE;
	}
		
	@SuppressWarnings("unchecked")
	public boolean supports(Class clazz) {
		return ProductImage.class.isAssignableFrom(clazz);
	}
	
	public Errors validate(ProductImage productImage) {
		Errors errors = createErrors(productImage);
		validate(productImage,errors);
		return errors;
	}

	public void validate(Object object, Errors errors) {
		ProductImage productImage = (ProductImage) object;
		if (isNameRequired(productImage)) {
			ValidationUtils.rejectIfEmptyOrWhitespace(errors, "name", "field.required");
		}
		if (isFileNameRequired(productImage)) {
			ValidationUtils.rejectIfEmptyOrWhitespace(errors, "fileName", "field.required");
		}
		if (isProductRequired(productImage)) {
			ValidationUtils.rejectIfEmpty(errors, "product", "field.required");
		}
	}
	
}
