package org.openxma.dsl.reference.validation;

import org.openxma.dsl.platform.validation.Validators;
import org.springframework.validation.Errors;

import org.openxma.dsl.reference.model.Supplier;
import org.springframework.validation.ValidationUtils;

public abstract class SupplierGenValidator extends Validators {
	
	public boolean isCompanyNameRequired(Supplier supplier) {
		return Boolean.TRUE;
	}
		
	@SuppressWarnings("unchecked")
	public boolean supports(Class clazz) {
		return Supplier.class.isAssignableFrom(clazz);
	}
	
	public Errors validate(Supplier supplier) {
		Errors errors = createErrors(supplier);
		validate(supplier,errors);
		return errors;
	}

	public void validate(Object object, Errors errors) {
		Supplier supplier = (Supplier) object;
		if (isCompanyNameRequired(supplier)) {
			ValidationUtils.rejectIfEmptyOrWhitespace(errors, "companyName", "field.required");
		}
	}
	
}
