package org.openxma.dsl.reference.validation;

import org.openxma.dsl.platform.validation.Validators;
import org.springframework.validation.Errors;

import org.openxma.dsl.reference.context.TestContext;
import org.openxma.dsl.reference.model.TestEntity;
import org.springframework.validation.ValidationUtils;

public abstract class TestEntityGenValidator extends Validators {
	private TestContext context;
	
	public TestContext getContext() {
		return context;
	}
	
	public void setContext(TestContext context) {
		this.context = context;
	}
	
	public boolean Flag01(TestEntity testEntity) {
		return !((("string"))).equals("string");
	}

	public boolean Flag02(TestEntity testEntity) {
		return Boolean.TRUE||Boolean.FALSE==((Boolean.FALSE||(1==1))&&Boolean.FALSE);
	}

	public boolean Flag03(TestEntity testEntity) {
		return (Flag01(testEntity)||Boolean.TRUE)&&Flag04(testEntity)&&Boolean.FALSE;
	}

	public boolean Flag04(TestEntity testEntity) {
		return Boolean.TRUE&&!("string").equals("string1")&&(1+2==3);
	}

	public boolean Flag05(TestEntity testEntity) {
		return ((!(getContext().getEnvironment()).equals(testEntity.getTestString1()))&&Boolean.TRUE&&(getContext().getIntProperty("key")==getValue(testEntity,"testInteger",Integer.class)));
	}

	public boolean Flag06(TestEntity testEntity) {
		return (!(getContext().getStringProperty("key")).equals(testEntity.getTestString1()))!=Boolean.TRUE;
	}

	public boolean Flag07(TestEntity testEntity) {
		return getContext().getIntProperty()!=getContext().getIntProperty("test");
	}

	public boolean Flag08(TestEntity testEntity) {
		return Boolean.TRUE&&!(getContext().getStringProperty("key")).equals(testEntity.getTestString1());
	}

	public boolean Flag09(TestEntity testEntity) {
		return Boolean.TRUE==Boolean.TRUE&&(getContext().getIntProperty()==1);
	}

	public boolean Flag10(TestEntity testEntity) {
		return !(testEntity.getTestString1()).equals(testEntity.getTestString2());
	}

	public boolean Flag11(TestEntity testEntity) {
		return ((testEntity.getTestString1()!=null)&&(testEntity.getTestString2()!=null))&&testEntity.getTestString1().equals(testEntity.getTestString2());
	}

	public boolean Flag12(TestEntity testEntity) {
		return (testEntity.getTestString1()!=null)&&!(testEntity.getTestString1()).equals("123");
	}

	public boolean Flag13(TestEntity testEntity) {
		return getContext().IsProd()||(getValue(testEntity,"testInteger",Integer.class)*5)==5;
	}

	public boolean Flag14(TestEntity testEntity) {
		return !(getContext().getEnvironment()).equals("test");
	}

	public boolean Flag15(TestEntity testEntity) {
		return (1+2+3-1)+(1+2)==8&&(getValue(testEntity,"testBoolean",Boolean.class)==Boolean.FALSE);
	}

	public boolean Flag16(TestEntity testEntity) {
		return Boolean.TRUE&&getContext().checkPermission("action")==Boolean.FALSE;
	}

	public boolean Flag17(TestEntity testEntity) {
		return getValue(testEntity,"testInteger",Integer.class).equals("123")||(getValue(testEntity,"testInteger",Integer.class)/2==1);
	}
	
	public boolean isTestString2Required(TestEntity testEntity) {
		return Flag02(testEntity);
	}
	
	public boolean isTestIntegerRequired(TestEntity testEntity) {
		return Flag03(testEntity);
	}
	
	public boolean isTestLongRequired(TestEntity testEntity) {
		return Flag04(testEntity);
	}
	
	public boolean isTestBooleanRequired(TestEntity testEntity) {
		return Flag05(testEntity);
	}
	
	public boolean isTestDoubleRequired(TestEntity testEntity) {
		return Flag06(testEntity);
	}
	
	public boolean isTestFloatRequired(TestEntity testEntity) {
		return Flag07(testEntity);
	}
	
	public boolean isTestString1Required(TestEntity testEntity) {
		return Flag01(testEntity);
	}
		
	@SuppressWarnings("unchecked")
	public boolean supports(Class clazz) {
		return TestEntity.class.isAssignableFrom(clazz);
	}
	
	public Errors validate(TestEntity testEntity) {
		Errors errors = createErrors(testEntity);
		validate(testEntity,errors);
		return errors;
	}

	public void validate(Object object, Errors errors) {
		TestEntity testEntity = (TestEntity) object;
		if (isTestString2Required(testEntity)) {
			ValidationUtils.rejectIfEmptyOrWhitespace(errors, "testString2", "field.required");
		}
		if (isTestIntegerRequired(testEntity)) {
			ValidationUtils.rejectIfEmpty(errors, "testInteger", "field.required");
		}
		if (isTestLongRequired(testEntity)) {
			ValidationUtils.rejectIfEmpty(errors, "testLong", "field.required");
		}
		if (isTestBooleanRequired(testEntity)) {
			ValidationUtils.rejectIfEmpty(errors, "testBoolean", "field.required");
		}
		if (isTestDoubleRequired(testEntity)) {
			ValidationUtils.rejectIfEmpty(errors, "testDouble", "field.required");
		}
		if (isTestFloatRequired(testEntity)) {
			ValidationUtils.rejectIfEmpty(errors, "testFloat", "field.required");
		}
		if (isTestString1Required(testEntity)) {
			ValidationUtils.rejectIfEmptyOrWhitespace(errors, "testString1", "field.required");
		}
		rejectIfMaxLength(errors,"testString1",testEntity.getTestString1(),100);
	}
	
}
