package org.openxma.dsl.reference.validation;

import org.openxma.dsl.platform.validation.Validators;
import org.springframework.validation.Errors;

import org.openxma.dsl.reference.model.VOData;
import org.springframework.validation.ValidationUtils;

public abstract class VODataGenValidator extends Validators {
	
	public boolean isPVOBigDecimalRequired(VOData vOData) {
		return Boolean.FALSE;
	}
	
	public boolean isPVODateRequired(VOData vOData) {
		return Boolean.FALSE;
	}
	
	public boolean isPVOTimestampRequired(VOData vOData) {
		return Boolean.FALSE;
	}
	
	public boolean isPVODoubleRequired(VOData vOData) {
		return Boolean.FALSE;
	}
	
	public boolean isPVOFloatRequired(VOData vOData) {
		return Boolean.FALSE;
	}
	
	public boolean isPVOIntegerRequired(VOData vOData) {
		return Boolean.FALSE;
	}
	
	public boolean isPVOLongRequired(VOData vOData) {
		return Boolean.FALSE;
	}
	
	public boolean isPVOStringRequired(VOData vOData) {
		return Boolean.FALSE;
	}
	
	public boolean isPVOBooleanRequired(VOData vOData) {
		return Boolean.FALSE;
	}
	
	public boolean isPVOI18EnumerationRequired(VOData vOData) {
		return Boolean.FALSE;
	}
	
	public boolean isPVOByteArrayRequired(VOData vOData) {
		return Boolean.FALSE;
	}
	
	public boolean isPVOXmlRequired(VOData vOData) {
		return Boolean.FALSE;
	}
	
	public boolean isPVOXml2Required(VOData vOData) {
		return Boolean.FALSE;
	}
		
	@SuppressWarnings("unchecked")
	public boolean supports(Class clazz) {
		return VOData.class.isAssignableFrom(clazz);
	}
	
	public Errors validate(VOData vOData) {
		Errors errors = createErrors(vOData);
		validate(vOData,errors);
		return errors;
	}

	public void validate(Object object, Errors errors) {
		VOData vOData = (VOData) object;
		if (isPVOBigDecimalRequired(vOData)) {
			ValidationUtils.rejectIfEmpty(errors, "pVOBigDecimal", "field.required");
		}
		if (isPVODateRequired(vOData)) {
			ValidationUtils.rejectIfEmpty(errors, "pVODate", "field.required");
		}
		if (isPVOTimestampRequired(vOData)) {
			ValidationUtils.rejectIfEmpty(errors, "pVOTimestamp", "field.required");
		}
		if (isPVODoubleRequired(vOData)) {
			ValidationUtils.rejectIfEmpty(errors, "pVODouble", "field.required");
		}
		if (isPVOFloatRequired(vOData)) {
			ValidationUtils.rejectIfEmpty(errors, "pVOFloat", "field.required");
		}
		if (isPVOIntegerRequired(vOData)) {
			ValidationUtils.rejectIfEmpty(errors, "pVOInteger", "field.required");
		}
		if (isPVOLongRequired(vOData)) {
			ValidationUtils.rejectIfEmpty(errors, "pVOLong", "field.required");
		}
		if (isPVOStringRequired(vOData)) {
			ValidationUtils.rejectIfEmptyOrWhitespace(errors, "pVOString", "field.required");
		}
		if (isPVOBooleanRequired(vOData)) {
			ValidationUtils.rejectIfEmpty(errors, "pVOBoolean", "field.required");
		}
		if (isPVOI18EnumerationRequired(vOData)) {
			ValidationUtils.rejectIfEmpty(errors, "pVOI18Enumeration", "field.required");
		}
		if (isPVOByteArrayRequired(vOData)) {
			ValidationUtils.rejectIfEmpty(errors, "pVOByteArray", "field.required");
		}
		if (isPVOXmlRequired(vOData)) {
			ValidationUtils.rejectIfEmpty(errors, "pVOXml", "field.required");
		}
		if (isPVOXml2Required(vOData)) {
			ValidationUtils.rejectIfEmpty(errors, "pVOXml2", "field.required");
		}
	}
	
}
