package org.openxma.dsl.reference.xma.customeredit.client;

import java.util.Locale;
import java.util.ResourceBundle;
import org.eclipse.swt.*;
import org.eclipse.swt.events.*;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.widgets.*;
import at.spardat.xma.widgets.DatePicker;
import at.spardat.xma.page.*;
import at.spardat.xma.mdl.*;
import at.spardat.enterprise.util.*;
import at.spardat.xma.mdl.list.*;
import at.spardat.xma.mdl.simple.*;
import at.spardat.enterprise.fmt.*;

/**
 * This class implements the generic client part of Page3.
 * It implements the widgets and models of the page.
 *
 */
public abstract class Page3Gen extends NotebookPage {
    Composite vodataCompositeW;
    Composite vodataComposite_set0W;
    Label vodataComposite_set0_centered;
    Label vodata_pVOBigDecimalL;
    Text vodata_pVOBigDecimalW;
    ISimpleWMClient vodata_pVOBigDecimal;
    Composite vodataComposite_set1W;
    Label vodataComposite_set1_centered;
    Label vodata_pVODateL;
    DatePicker vodata_pVODateW;
    ISimpleWMClient vodata_pVODate;
    Composite vodataComposite_set2W;
    Label vodataComposite_set2_centered;
    Label vodata_pVOTimestampL;
    Text vodata_pVOTimestampW;
    ISimpleWMClient vodata_pVOTimestamp;
    Composite vodataComposite_set3W;
    Label vodataComposite_set3_centered;
    Label vodata_pVODoubleL;
    Text vodata_pVODoubleW;
    ISimpleWMClient vodata_pVODouble;
    Composite vodataComposite_set4W;
    Label vodataComposite_set4_centered;
    Label vodata_pVOFloatL;
    Text vodata_pVOFloatW;
    ISimpleWMClient vodata_pVOFloat;
    Composite vodataComposite_set5W;
    Label vodataComposite_set5_centered;
    Label vodata_pVOIntegerL;
    Text vodata_pVOIntegerW;
    ISimpleWMClient vodata_pVOInteger;
    Composite vodataComposite_set6W;
    Label vodataComposite_set6_centered;
    Label vodata_pVOLongL;
    Text vodata_pVOLongW;
    ISimpleWMClient vodata_pVOLong;
    Composite vodataComposite_set7W;
    Label vodataComposite_set7_centered;
    Label vodata_pVOStringL;
    Text vodata_pVOStringW;
    ISimpleWMClient vodata_pVOString;
    Composite vodataComposite_set8W;
    Label vodataComposite_set8_centered;
    Button vodata_pVOBooleanW;
    ISimpleWMClient vodata_pVOBoolean;
    Composite vodataComposite_set9W;
    Label vodataComposite_set9_centered;
    Label vodata_pVOI18EnumerationL;
    Combo vodata_pVOI18EnumerationW;
    IListDomWMClient vodata_pVOI18Enumeration;
    WModel[] widgetModels;
    Control[] widgets;

    /**
     * Constructs the Page3Gen.
     * @param notebook the Notebook this page belongs to.
     */
    public Page3Gen(Notebook notebook) {
        super(notebook,false);
        createModels();
    }

    /**
     * Create and initialize the WidgetModels of the page.
     * Subpages which are not lazy are created too.
     */
    public void createModels() {
        Locale locale = getComponent().getContext().getLocale();
        IFmt formatter;
        CompoundValidator compound;
        vodata_pVOBigDecimal = new SimpleWMClient((short) 0, Types.T_BCD, this);
        formatter = ABcdFmt.getInstance(-1, -1, ABcdFmt.DEFAULT, locale);
        compound = new CompoundValidator(formatter);
        formatter = ABcdFmt.getInstance(-1, -1, ABcdFmt.DEFAULT, locale);
        compound.setFormatter(formatter);
        formatter = compound;
        vodata_pVOBigDecimal.setFmt(formatter);
        vodata_pVODate = new SimpleWMClient((short) 1, Types.T_DATE, this);
        formatter = ADateFmt.getInstance(ADateFmt.MEDIUM, locale);
        compound = new CompoundValidator(formatter);
        formatter = ADateFmt.getInstance(ADateFmt.MEDIUM, locale);
        compound.setFormatter(formatter);
        formatter = compound;
        vodata_pVODate.setFmt(formatter);
        vodata_pVOTimestamp = new SimpleWMClient((short) 2, Types.T_TIMESTAMP, this);
        formatter = ATimeStampFmt.getInstance(ATimeStampFmt.MEDIUM, ATimeStampFmt.MEDIUM, locale);
        compound = new CompoundValidator(formatter);
        formatter = ATimeStampFmt.getInstance(ATimeStampFmt.MEDIUM, ATimeStampFmt.MEDIUM, locale);
        compound.setFormatter(formatter);
        formatter = compound;
        vodata_pVOTimestamp.setFmt(formatter);
        vodata_pVODouble = new SimpleWMClient((short) 3, Types.T_BCD, this);
        formatter = ABcdFmt.getInstance(-1, -1, ABcdFmt.DEFAULT, locale);
        compound = new CompoundValidator(formatter);
        formatter = ABcdFmt.getInstance(-1, -1, ABcdFmt.DEFAULT, locale);
        compound.setFormatter(formatter);
        formatter = compound;
        vodata_pVODouble.setFmt(formatter);
        vodata_pVOFloat = new SimpleWMClient((short) 4, Types.T_BCD, this);
        formatter = ABcdFmt.getInstance(-1, -1, ABcdFmt.DEFAULT, locale);
        compound = new CompoundValidator(formatter);
        formatter = ABcdFmt.getInstance(-1, -1, ABcdFmt.DEFAULT, locale);
        compound.setFormatter(formatter);
        formatter = compound;
        vodata_pVOFloat.setFmt(formatter);
        vodata_pVOInteger = new SimpleWMClient((short) 5, Types.T_BCD, this);
        formatter = ABcdFmt.getInstance(10, 0, ABcdFmt.DEFAULT, -2147483648, 2147483647, locale);
        compound = new CompoundValidator(formatter);
        formatter = ABcdFmt.getInstance(10, 0, ABcdFmt.DEFAULT, -2147483648, 2147483647, locale);
        compound.setFormatter(formatter);
        formatter = compound;
        vodata_pVOInteger.setFmt(formatter);
        vodata_pVOLong = new SimpleWMClient((short) 6, Types.T_BCD, this);
        formatter = ABcdFmt.getInstance(-1, -1, ABcdFmt.DEFAULT, locale);
        compound = new CompoundValidator(formatter);
        formatter = ABcdFmt.getInstance(-1, -1, ABcdFmt.DEFAULT, locale);
        compound.setFormatter(formatter);
        formatter = compound;
        vodata_pVOLong.setFmt(formatter);
        vodata_pVOString = new SimpleWMClient((short) 7, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        compound = new CompoundValidator(formatter);
        formatter = AStringFmt.getInstance(-1);
        compound.setFormatter(formatter);
        formatter = compound;
        vodata_pVOString.setFmt(formatter);
        vodata_pVOBoolean = new SimpleWMClient((short) 8, Types.T_BOOLEAN, this);
        vodata_pVOI18Enumeration = new ListDomWMClient((short) 9,this, null, ListDomWMClient.SHOW_LONG);
        ((ListDomWMClient)vodata_pVOI18Enumeration).setOrderStyle(ListDomWMClient.ORDER_NATURAL);
        ((ListDomWMClient)vodata_pVOI18Enumeration).setDynamicDataSource(true);

        widgetModels = new WModel[] { (WModel) vodata_pVOBigDecimal, (WModel) vodata_pVODate, (WModel) vodata_pVOTimestamp, (WModel) vodata_pVODouble, (WModel) vodata_pVOFloat, (WModel) vodata_pVOInteger, (WModel) vodata_pVOLong, (WModel) vodata_pVOString, (WModel) vodata_pVOBoolean, (WModel) vodata_pVOI18Enumeration };
        getComponent().registerPageModel(this);
    }

    /**
     * Indicate if the WidgetModels are already created.
     * @return true if the WidgetModels exist.
     */
    public boolean hasModels() {
        return widgetModels != null;
    }

    /**
     * Remove all WidgetModels of the page.
     */
    public void removeWidgetModels() {
        vodata_pVOBigDecimal = null;
        vodata_pVODate = null;
        vodata_pVOTimestamp = null;
        vodata_pVODouble = null;
        vodata_pVOFloat = null;
        vodata_pVOInteger = null;
        vodata_pVOLong = null;
        vodata_pVOString = null;
        vodata_pVOBoolean = null;
        vodata_pVOI18Enumeration = null;
        widgetModels = null;
    }

    /**
     * Returns an array of all WidgetModels of this page.
     * @return array of WidgetModels. The returned array is not a copy, therefore
     *          it must not be modified.
     */
    public WModel[] getWModels() {
        return widgetModels;
    }

    /**
     * Replaces the model array generated by guidesigner.
     * May only be called by the runtime. Do not call this method!
     */
    protected void setWModels(WModel[] models) {
        widgetModels=models;
    }

    /**
     * Returns a unique id to identify the type of this Page.
     * @return the typeId
     */
    public short getTypeId() {
        return CustomerEdit.Page3Class;
    }

    /**
     * Returns the component this page belongs to, casted to its actual type.
     * @return The Component. Never null.
     */
    public CustomerEdit getTypedComponent() {
        return (CustomerEdit) getComponent();
    }

    /**
     * Returns an array of all Widgets of this page.
     * @return array of Widgets. The returned array is not a copy, therefore
     *          it must not be modified.
     */
    public Control[] getWidgets() {
        return widgets;
    }

    /**
     * Replaces the widget array generated by guidesigner.
     * May only be called by the runtime. Do not call this method!
     */
    protected void setWidgets(Control[] widgets) {
        this.widgets=widgets;
    }

    /**
     * Create and initialize all SWT-Widgets of the page.
     * It <br>
     * <ul>
     * <li> instantiates the Widgets </li>
     * <li> sets constant texts (Title, Labels, Tooltips) and Images </li>
     * <li> registers the eventadapter </li>
     * <li> defines the Layout (Attachments, Distances, Sizes) </li>
     * <li> sets the focus </li>
     * <li> defines the Taborder </li>
     * </ul>
     */
    protected void createWidgets() {
        FormData data;
        Control[] tabOrder;
        EventAdapter adapter = new EventAdapter(this);
        Locale locale = getComponent().getContext().getLocale();
        ResourceBundle messages = ResourceBundle.getBundle("org.openxma.dsl.reference.xma.customeredit.client.CustomerEdit",locale);
        final Scaler scaler = Scaler.getInstance(getComposite());
        Control lastControl;

        Composite pageCompositePage3W = getComposite();
        FormLayout layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        pageCompositePage3W.setLayout(layout);

        vodataCompositeW = new Composite(pageCompositePage3W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        vodataCompositeW.setLayout(layout);
        vodataCompositeW.setData("WIDGET_ID","vodataCompositeW");

        vodataComposite_set0W = new Composite(vodataCompositeW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        vodataComposite_set0W.setLayout(layout);
        vodataComposite_set0W.setData("WIDGET_ID","vodataComposite_set0W");

        vodataComposite_set0_centered = new Label (vodataComposite_set0W,SWT.LEFT);
        vodataComposite_set0_centered.setVisible(false);
        vodataComposite_set0_centered.setData("WIDGET_ID","vodataComposite_set0_centered");

        vodata_pVOBigDecimalL = new Label (vodataComposite_set0W,SWT.LEFT|SWT.WRAP);
        vodata_pVOBigDecimalL.setText(messages.getString("Page3.vodata_pVOBigDecimalL"));
        vodata_pVOBigDecimalL.setData("WIDGET_ID","vodata_pVOBigDecimalL");

        vodata_pVOBigDecimalW = new Text(vodataComposite_set0W, SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        vodata_pVOBigDecimalW.setToolTipText(messages.getString("Page3.vodata_pVOBigDecimalWTip"));
        vodata_pVOBigDecimalW.setData("WIDGET_ID","vodata_pVOBigDecimalW");
        vodata_pVOBigDecimalW.addFocusListener(adapter);
        vodata_pVOBigDecimalW.addModifyListener(adapter);
        vodata_pVOBigDecimalW.addVerifyListener(adapter);

        vodataComposite_set1W = new Composite(vodataCompositeW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        vodataComposite_set1W.setLayout(layout);
        vodataComposite_set1W.setData("WIDGET_ID","vodataComposite_set1W");

        vodataComposite_set1_centered = new Label (vodataComposite_set1W,SWT.LEFT);
        vodataComposite_set1_centered.setVisible(false);
        vodataComposite_set1_centered.setData("WIDGET_ID","vodataComposite_set1_centered");

        vodata_pVODateL = new Label (vodataComposite_set1W,SWT.LEFT|SWT.WRAP);
        vodata_pVODateL.setText(messages.getString("Page3.vodata_pVODateL"));
        vodata_pVODateL.setData("WIDGET_ID","vodata_pVODateL");

        vodata_pVODateW = new DatePicker(vodataComposite_set1W, SWT.SINGLE|SWT.BORDER|SWT.LEFT,DatePicker.RED_WEEKEND);
        vodata_pVODateW.setDatePickerLocale(locale);
        vodata_pVODateW.setToolTipText(messages.getString("Page3.vodata_pVODateWTip"));
        vodata_pVODateW.setData("WIDGET_ID","vodata_pVODateW");
        vodata_pVODateW.getDateTextField().addFocusListener(adapter);
        vodata_pVODateW.getDateTextField().addModifyListener(adapter);
        vodata_pVODateW.getDateTextField().addVerifyListener(adapter);

        vodataComposite_set2W = new Composite(vodataCompositeW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        vodataComposite_set2W.setLayout(layout);
        vodataComposite_set2W.setData("WIDGET_ID","vodataComposite_set2W");

        vodataComposite_set2_centered = new Label (vodataComposite_set2W,SWT.LEFT);
        vodataComposite_set2_centered.setVisible(false);
        vodataComposite_set2_centered.setData("WIDGET_ID","vodataComposite_set2_centered");

        vodata_pVOTimestampL = new Label (vodataComposite_set2W,SWT.LEFT|SWT.WRAP);
        vodata_pVOTimestampL.setText(messages.getString("Page3.vodata_pVOTimestampL"));
        vodata_pVOTimestampL.setData("WIDGET_ID","vodata_pVOTimestampL");

        vodata_pVOTimestampW = new Text(vodataComposite_set2W, SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        vodata_pVOTimestampW.setToolTipText(messages.getString("Page3.vodata_pVOTimestampWTip"));
        vodata_pVOTimestampW.setData("WIDGET_ID","vodata_pVOTimestampW");
        vodata_pVOTimestampW.addFocusListener(adapter);
        vodata_pVOTimestampW.addModifyListener(adapter);
        vodata_pVOTimestampW.addVerifyListener(adapter);

        vodataComposite_set3W = new Composite(vodataCompositeW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        vodataComposite_set3W.setLayout(layout);
        vodataComposite_set3W.setData("WIDGET_ID","vodataComposite_set3W");

        vodataComposite_set3_centered = new Label (vodataComposite_set3W,SWT.LEFT);
        vodataComposite_set3_centered.setVisible(false);
        vodataComposite_set3_centered.setData("WIDGET_ID","vodataComposite_set3_centered");

        vodata_pVODoubleL = new Label (vodataComposite_set3W,SWT.LEFT|SWT.WRAP);
        vodata_pVODoubleL.setText(messages.getString("Page3.vodata_pVODoubleL"));
        vodata_pVODoubleL.setData("WIDGET_ID","vodata_pVODoubleL");

        vodata_pVODoubleW = new Text(vodataComposite_set3W, SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        vodata_pVODoubleW.setToolTipText(messages.getString("Page3.vodata_pVODoubleWTip"));
        vodata_pVODoubleW.setData("WIDGET_ID","vodata_pVODoubleW");
        vodata_pVODoubleW.addFocusListener(adapter);
        vodata_pVODoubleW.addModifyListener(adapter);
        vodata_pVODoubleW.addVerifyListener(adapter);

        vodataComposite_set4W = new Composite(vodataCompositeW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        vodataComposite_set4W.setLayout(layout);
        vodataComposite_set4W.setData("WIDGET_ID","vodataComposite_set4W");

        vodataComposite_set4_centered = new Label (vodataComposite_set4W,SWT.LEFT);
        vodataComposite_set4_centered.setVisible(false);
        vodataComposite_set4_centered.setData("WIDGET_ID","vodataComposite_set4_centered");

        vodata_pVOFloatL = new Label (vodataComposite_set4W,SWT.LEFT|SWT.WRAP);
        vodata_pVOFloatL.setText(messages.getString("Page3.vodata_pVOFloatL"));
        vodata_pVOFloatL.setData("WIDGET_ID","vodata_pVOFloatL");

        vodata_pVOFloatW = new Text(vodataComposite_set4W, SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        vodata_pVOFloatW.setToolTipText(messages.getString("Page3.vodata_pVOFloatWTip"));
        vodata_pVOFloatW.setData("WIDGET_ID","vodata_pVOFloatW");
        vodata_pVOFloatW.addFocusListener(adapter);
        vodata_pVOFloatW.addModifyListener(adapter);
        vodata_pVOFloatW.addVerifyListener(adapter);

        vodataComposite_set5W = new Composite(vodataCompositeW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        vodataComposite_set5W.setLayout(layout);
        vodataComposite_set5W.setData("WIDGET_ID","vodataComposite_set5W");

        vodataComposite_set5_centered = new Label (vodataComposite_set5W,SWT.LEFT);
        vodataComposite_set5_centered.setVisible(false);
        vodataComposite_set5_centered.setData("WIDGET_ID","vodataComposite_set5_centered");

        vodata_pVOIntegerL = new Label (vodataComposite_set5W,SWT.LEFT|SWT.WRAP);
        vodata_pVOIntegerL.setText(messages.getString("Page3.vodata_pVOIntegerL"));
        vodata_pVOIntegerL.setData("WIDGET_ID","vodata_pVOIntegerL");

        vodata_pVOIntegerW = new Text(vodataComposite_set5W, SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        vodata_pVOIntegerW.setToolTipText(messages.getString("Page3.vodata_pVOIntegerWTip"));
        vodata_pVOIntegerW.setData("WIDGET_ID","vodata_pVOIntegerW");
        vodata_pVOIntegerW.addFocusListener(adapter);
        vodata_pVOIntegerW.addModifyListener(adapter);
        vodata_pVOIntegerW.addVerifyListener(adapter);

        vodataComposite_set6W = new Composite(vodataCompositeW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        vodataComposite_set6W.setLayout(layout);
        vodataComposite_set6W.setData("WIDGET_ID","vodataComposite_set6W");

        vodataComposite_set6_centered = new Label (vodataComposite_set6W,SWT.LEFT);
        vodataComposite_set6_centered.setVisible(false);
        vodataComposite_set6_centered.setData("WIDGET_ID","vodataComposite_set6_centered");

        vodata_pVOLongL = new Label (vodataComposite_set6W,SWT.LEFT|SWT.WRAP);
        vodata_pVOLongL.setText(messages.getString("Page3.vodata_pVOLongL"));
        vodata_pVOLongL.setData("WIDGET_ID","vodata_pVOLongL");

        vodata_pVOLongW = new Text(vodataComposite_set6W, SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        vodata_pVOLongW.setToolTipText(messages.getString("Page3.vodata_pVOLongWTip"));
        vodata_pVOLongW.setData("WIDGET_ID","vodata_pVOLongW");
        vodata_pVOLongW.addFocusListener(adapter);
        vodata_pVOLongW.addModifyListener(adapter);
        vodata_pVOLongW.addVerifyListener(adapter);

        vodataComposite_set7W = new Composite(vodataCompositeW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        vodataComposite_set7W.setLayout(layout);
        vodataComposite_set7W.setData("WIDGET_ID","vodataComposite_set7W");

        vodataComposite_set7_centered = new Label (vodataComposite_set7W,SWT.LEFT);
        vodataComposite_set7_centered.setVisible(false);
        vodataComposite_set7_centered.setData("WIDGET_ID","vodataComposite_set7_centered");

        vodata_pVOStringL = new Label (vodataComposite_set7W,SWT.LEFT|SWT.WRAP);
        vodata_pVOStringL.setText(messages.getString("Page3.vodata_pVOStringL"));
        vodata_pVOStringL.setData("WIDGET_ID","vodata_pVOStringL");

        vodata_pVOStringW = new Text(vodataComposite_set7W, SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        vodata_pVOStringW.setToolTipText(messages.getString("Page3.vodata_pVOStringWTip"));
        vodata_pVOStringW.setData("WIDGET_ID","vodata_pVOStringW");
        vodata_pVOStringW.addFocusListener(adapter);
        vodata_pVOStringW.addModifyListener(adapter);
        vodata_pVOStringW.addVerifyListener(adapter);

        vodataComposite_set8W = new Composite(vodataCompositeW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        vodataComposite_set8W.setLayout(layout);
        vodataComposite_set8W.setData("WIDGET_ID","vodataComposite_set8W");

        vodataComposite_set8_centered = new Label (vodataComposite_set8W,SWT.LEFT);
        vodataComposite_set8_centered.setVisible(false);
        vodataComposite_set8_centered.setData("WIDGET_ID","vodataComposite_set8_centered");

        vodata_pVOBooleanW = new Button (vodataComposite_set8W, SWT.CHECK|SWT.LEFT);
        vodata_pVOBooleanW.setText(messages.getString("Page3.vodata_pVOBooleanW"));
        vodata_pVOBooleanW.setToolTipText(messages.getString("Page3.vodata_pVOBooleanWTip"));
        vodata_pVOBooleanW.setData("WIDGET_ID","vodata_pVOBooleanW");
        vodata_pVOBooleanW.addSelectionListener(adapter);

        vodataComposite_set9W = new Composite(vodataCompositeW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        vodataComposite_set9W.setLayout(layout);
        vodataComposite_set9W.setData("WIDGET_ID","vodataComposite_set9W");

        vodataComposite_set9_centered = new Label (vodataComposite_set9W,SWT.LEFT);
        vodataComposite_set9_centered.setVisible(false);
        vodataComposite_set9_centered.setData("WIDGET_ID","vodataComposite_set9_centered");

        vodata_pVOI18EnumerationL = new Label (vodataComposite_set9W,SWT.LEFT|SWT.WRAP);
        vodata_pVOI18EnumerationL.setText(messages.getString("Page3.vodata_pVOI18EnumerationL"));
        vodata_pVOI18EnumerationL.setData("WIDGET_ID","vodata_pVOI18EnumerationL");

        vodata_pVOI18EnumerationW = new Combo(vodataComposite_set9W, SWT.DROP_DOWN|SWT.BORDER);
        vodata_pVOI18EnumerationW.setToolTipText(messages.getString("Page3.vodata_pVOI18EnumerationWTip"));
        vodata_pVOI18EnumerationW.setData("WIDGET_ID","vodata_pVOI18EnumerationW");
        vodata_pVOI18EnumerationW.addFocusListener(adapter);
        vodata_pVOI18EnumerationW.addModifyListener(adapter);
        vodata_pVOI18EnumerationW.addSelectionListener(adapter);

        widgets = new Control[] { vodataCompositeW, vodataComposite_set0W, vodataComposite_set0_centered, vodata_pVOBigDecimalL, vodata_pVOBigDecimalW, vodataComposite_set1W, vodataComposite_set1_centered, vodata_pVODateL, vodata_pVODateW, vodataComposite_set2W, vodataComposite_set2_centered, vodata_pVOTimestampL, vodata_pVOTimestampW, vodataComposite_set3W, vodataComposite_set3_centered, vodata_pVODoubleL, vodata_pVODoubleW, vodataComposite_set4W, vodataComposite_set4_centered, vodata_pVOFloatL, vodata_pVOFloatW, vodataComposite_set5W, vodataComposite_set5_centered, vodata_pVOIntegerL, vodata_pVOIntegerW, vodataComposite_set6W, vodataComposite_set6_centered, vodata_pVOLongL, vodata_pVOLongW, vodataComposite_set7W, vodataComposite_set7_centered, vodata_pVOStringL, vodata_pVOStringW, vodataComposite_set8W, vodataComposite_set8_centered, vodata_pVOBooleanW, vodataComposite_set9W, vodataComposite_set9_centered, vodata_pVOI18EnumerationL, vodata_pVOI18EnumerationW };

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(10));
        vodataCompositeW.setLayoutData(data);

        lastControl=null;
        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        vodataComposite_set0W.setLayoutData(data);
        lastControl=vodataComposite_set0W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        vodataComposite_set1W.setLayoutData(data);
        lastControl=vodataComposite_set1W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        vodataComposite_set2W.setLayoutData(data);
        lastControl=vodataComposite_set2W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        vodataComposite_set3W.setLayoutData(data);
        lastControl=vodataComposite_set3W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        vodataComposite_set4W.setLayoutData(data);
        lastControl=vodataComposite_set4W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        vodataComposite_set5W.setLayoutData(data);
        lastControl=vodataComposite_set5W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        vodataComposite_set6W.setLayoutData(data);
        lastControl=vodataComposite_set6W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        vodataComposite_set7W.setLayoutData(data);
        lastControl=vodataComposite_set7W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        vodataComposite_set8W.setLayoutData(data);
        lastControl=vodataComposite_set8W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        vodataComposite_set9W.setLayoutData(data);
        lastControl=vodataComposite_set9W;

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        vodataComposite_set0_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(0,100,scaler.convertXToCurrent(130));
        data.top = new FormAttachment(vodataComposite_set0_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        vodata_pVOBigDecimalL.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(133));
        data.top = new FormAttachment(vodataComposite_set0_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        vodata_pVOBigDecimalW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        vodataComposite_set1_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(0,100,scaler.convertXToCurrent(130));
        data.top = new FormAttachment(vodataComposite_set1_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        vodata_pVODateL.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(133));
        data.top = new FormAttachment(vodataComposite_set1_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        vodata_pVODateW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        vodataComposite_set2_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(0,100,scaler.convertXToCurrent(130));
        data.top = new FormAttachment(vodataComposite_set2_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        vodata_pVOTimestampL.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(133));
        data.top = new FormAttachment(vodataComposite_set2_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        vodata_pVOTimestampW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        vodataComposite_set3_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(0,100,scaler.convertXToCurrent(130));
        data.top = new FormAttachment(vodataComposite_set3_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        vodata_pVODoubleL.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(133));
        data.top = new FormAttachment(vodataComposite_set3_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        vodata_pVODoubleW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        vodataComposite_set4_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(0,100,scaler.convertXToCurrent(130));
        data.top = new FormAttachment(vodataComposite_set4_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        vodata_pVOFloatL.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(133));
        data.top = new FormAttachment(vodataComposite_set4_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        vodata_pVOFloatW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        vodataComposite_set5_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(0,100,scaler.convertXToCurrent(130));
        data.top = new FormAttachment(vodataComposite_set5_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        vodata_pVOIntegerL.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(133));
        data.top = new FormAttachment(vodataComposite_set5_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        vodata_pVOIntegerW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        vodataComposite_set6_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(0,100,scaler.convertXToCurrent(130));
        data.top = new FormAttachment(vodataComposite_set6_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        vodata_pVOLongL.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(133));
        data.top = new FormAttachment(vodataComposite_set6_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        vodata_pVOLongW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        vodataComposite_set7_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(0,100,scaler.convertXToCurrent(130));
        data.top = new FormAttachment(vodataComposite_set7_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        vodata_pVOStringL.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(133));
        data.top = new FormAttachment(vodataComposite_set7_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        vodata_pVOStringW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        vodataComposite_set8_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(vodataComposite_set8_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        vodata_pVOBooleanW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        vodataComposite_set9_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(0,100,scaler.convertXToCurrent(130));
        data.top = new FormAttachment(vodataComposite_set9_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        vodata_pVOI18EnumerationL.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(133));
        data.top = new FormAttachment(vodataComposite_set9_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        vodata_pVOI18EnumerationW.setLayoutData(data);


        tabOrder = new Control[1];
        tabOrder[0] = vodataCompositeW;
        pageCompositePage3W.setTabList(tabOrder);
        tabOrder = new Control[10];
        tabOrder[0] = vodataComposite_set0W;
        tabOrder[1] = vodataComposite_set1W;
        tabOrder[2] = vodataComposite_set2W;
        tabOrder[3] = vodataComposite_set3W;
        tabOrder[4] = vodataComposite_set4W;
        tabOrder[5] = vodataComposite_set5W;
        tabOrder[6] = vodataComposite_set6W;
        tabOrder[7] = vodataComposite_set7W;
        tabOrder[8] = vodataComposite_set8W;
        tabOrder[9] = vodataComposite_set9W;
        vodataCompositeW.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = vodata_pVOBigDecimalW;
        vodataComposite_set0W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = vodata_pVODateW;
        vodataComposite_set1W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = vodata_pVOTimestampW;
        vodataComposite_set2W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = vodata_pVODoubleW;
        vodataComposite_set3W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = vodata_pVOFloatW;
        vodataComposite_set4W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = vodata_pVOIntegerW;
        vodataComposite_set5W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = vodata_pVOLongW;
        vodataComposite_set6W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = vodata_pVOStringW;
        vodataComposite_set7W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = vodata_pVOBooleanW;
        vodataComposite_set8W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = vodata_pVOI18EnumerationW;
        vodataComposite_set9W.setTabList(tabOrder);
    }

    /**
     * Remove all Widgets of the page after they have been disposed.
     */
    public void removeWidgets() {
        vodataCompositeW = null;
        vodataComposite_set0W = null;
        vodataComposite_set0_centered = null;
        vodata_pVOBigDecimalL = null;
        vodata_pVOBigDecimalW = null;
        vodataComposite_set1W = null;
        vodataComposite_set1_centered = null;
        vodata_pVODateL = null;
        vodata_pVODateW = null;
        vodataComposite_set2W = null;
        vodataComposite_set2_centered = null;
        vodata_pVOTimestampL = null;
        vodata_pVOTimestampW = null;
        vodataComposite_set3W = null;
        vodataComposite_set3_centered = null;
        vodata_pVODoubleL = null;
        vodata_pVODoubleW = null;
        vodataComposite_set4W = null;
        vodataComposite_set4_centered = null;
        vodata_pVOFloatL = null;
        vodata_pVOFloatW = null;
        vodataComposite_set5W = null;
        vodataComposite_set5_centered = null;
        vodata_pVOIntegerL = null;
        vodata_pVOIntegerW = null;
        vodataComposite_set6W = null;
        vodataComposite_set6_centered = null;
        vodata_pVOLongL = null;
        vodata_pVOLongW = null;
        vodataComposite_set7W = null;
        vodataComposite_set7_centered = null;
        vodata_pVOStringL = null;
        vodata_pVOStringW = null;
        vodataComposite_set8W = null;
        vodataComposite_set8_centered = null;
        vodata_pVOBooleanW = null;
        vodataComposite_set9W = null;
        vodataComposite_set9_centered = null;
        vodata_pVOI18EnumerationL = null;
        vodata_pVOI18EnumerationW = null;
        widgets = null;
    }


    /**
     * Attaches all WidgetModels of the page to there corresponding Widgets.
     */
    public void attachUIImpl() throws AttachmentExceptionClient {
        vodata_pVOBigDecimalW.setData(vodata_pVOBigDecimal.getUIDelegate());
        vodata_pVOBigDecimal.getUIDelegate().attachUI(vodata_pVOBigDecimalW,vodata_pVOBigDecimalL);
        vodata_pVODateW.getDateTextField().setData(vodata_pVODate.getUIDelegate());
        vodata_pVODate.getUIDelegate().attachUI(vodata_pVODateW.getDateTextField(),vodata_pVODateL);
        vodata_pVOTimestampW.setData(vodata_pVOTimestamp.getUIDelegate());
        vodata_pVOTimestamp.getUIDelegate().attachUI(vodata_pVOTimestampW,vodata_pVOTimestampL);
        vodata_pVODoubleW.setData(vodata_pVODouble.getUIDelegate());
        vodata_pVODouble.getUIDelegate().attachUI(vodata_pVODoubleW,vodata_pVODoubleL);
        vodata_pVOFloatW.setData(vodata_pVOFloat.getUIDelegate());
        vodata_pVOFloat.getUIDelegate().attachUI(vodata_pVOFloatW,vodata_pVOFloatL);
        vodata_pVOIntegerW.setData(vodata_pVOInteger.getUIDelegate());
        vodata_pVOInteger.getUIDelegate().attachUI(vodata_pVOIntegerW,vodata_pVOIntegerL);
        vodata_pVOLongW.setData(vodata_pVOLong.getUIDelegate());
        vodata_pVOLong.getUIDelegate().attachUI(vodata_pVOLongW,vodata_pVOLongL);
        vodata_pVOStringW.setData(vodata_pVOString.getUIDelegate());
        vodata_pVOString.getUIDelegate().attachUI(vodata_pVOStringW,vodata_pVOStringL);
        vodata_pVOBooleanW.setData(vodata_pVOBoolean.getUIDelegate());
        vodata_pVOBoolean.getUIDelegate().attachUI(vodata_pVOBooleanW,null);
        vodata_pVOI18EnumerationW.setData(vodata_pVOI18Enumeration.getUIDelegate());
        vodata_pVOI18Enumeration.getUIDelegate().attachUI(vodata_pVOI18EnumerationW,vodata_pVOI18EnumerationL);
    }

    /**
     * Enables or disables Widgets according to the current state of the page.
     * This method is called every time the content of any WizardModel of the
     * Page may have been changed. <br>
     * This method is called immediately after {@link #determineState()}.
     */
    public void stateChanged() {

        vodata_pVOBigDecimal.setMandatory(false);
        vodata_pVODate.setMandatory(false);
        vodata_pVOTimestamp.setMandatory(false);
        vodata_pVODouble.setMandatory(false);
        vodata_pVOFloat.setMandatory(false);
        vodata_pVOInteger.setMandatory(false);
        vodata_pVOLong.setMandatory(false);
        vodata_pVOString.setMandatory(false);
        vodata_pVOI18Enumeration.setMandatory(false);
    }

    /**
     * Calls the clientevent configured for the widget of the event.
     *
     * @param event the SWT-Event that happened.
     * @param type the type of the Event, as defined by the event type constants in class SWT.
     */
    protected void clientEvent(SelectionEvent event,int type) {
    }

    /**
     * Creates the coresponding TabItem
     */
    protected TabItem createTabItem(TabFolder tabfolder1W,int index) {
        Locale locale = getComponent().getContext().getLocale();
        ResourceBundle messages = ResourceBundle.getBundle("org.openxma.dsl.reference.xma.customeredit.client.CustomerEdit",locale);

        TabItem page3W = new TabItem (tabfolder1W, SWT.NULL, index);
        page3W.setText(messages.getString("Page3"));
        page3W.setControl(getComposite());
        page3W.setData(this);

        return page3W;
    }
}
