package org.openxma.dsl.reference.xma.customeredit.server;

import at.spardat.xma.page.*;
import at.spardat.xma.component.*;
import at.spardat.xma.mdl.*;
import at.spardat.enterprise.util.*;
import at.spardat.xma.mdl.list.*;
import at.spardat.xma.mdl.simple.*;

/**
 * This class implements the generic server part of Page3.
 * It implements the models of the page.
 *
 */
public abstract class Page3Gen extends PageServer {
    ISimpleWM vodata_pVOBigDecimal;
    ISimpleWM vodata_pVODate;
    ISimpleWM vodata_pVOTimestamp;
    ISimpleWM vodata_pVODouble;
    ISimpleWM vodata_pVOFloat;
    ISimpleWM vodata_pVOInteger;
    ISimpleWM vodata_pVOLong;
    ISimpleWM vodata_pVOString;
    ISimpleWM vodata_pVOBoolean;
    IListDomWM vodata_pVOI18Enumeration;
    WModel[] widgetModels;


    /**
     * Constructs the Page3Gen.
     * This constructor is called by the runtime. Do not remove!
     *
     * @param component the component this page belongs to
     */
    public Page3Gen(ComponentServer component) {
        super(component, false);
        createModels();
    }

    /**
     * Create and initialize the WidgetModels of the page.
     */
    public void createModels() {
        vodata_pVOBigDecimal = new SimpleWM((short) 0, Types.T_BCD, this);
        vodata_pVODate = new SimpleWM((short) 1, Types.T_DATE, this);
        vodata_pVOTimestamp = new SimpleWM((short) 2, Types.T_TIMESTAMP, this);
        vodata_pVODouble = new SimpleWM((short) 3, Types.T_BCD, this);
        vodata_pVOFloat = new SimpleWM((short) 4, Types.T_BCD, this);
        vodata_pVOInteger = new SimpleWM((short) 5, Types.T_BCD, this);
        vodata_pVOLong = new SimpleWM((short) 6, Types.T_BCD, this);
        vodata_pVOString = new SimpleWM((short) 7, Types.T_STRING, this);
        vodata_pVOBoolean = new SimpleWM((short) 8, Types.T_BOOLEAN, this);
        vodata_pVOI18Enumeration = new ListDomWM((short) 9,this, "null");
        ((ListDomWM)vodata_pVOI18Enumeration).setDynamicDataSource(true);

        widgetModels = new WModel[] { (WModel) vodata_pVOBigDecimal, (WModel) vodata_pVODate, (WModel) vodata_pVOTimestamp, (WModel) vodata_pVODouble, (WModel) vodata_pVOFloat, (WModel) vodata_pVOInteger, (WModel) vodata_pVOLong, (WModel) vodata_pVOString, (WModel) vodata_pVOBoolean, (WModel) vodata_pVOI18Enumeration };
    }

    /**
     * Returns an array of all WidgetModels of this page.
     * @return array of WidgetModels. The returned array is not a copy, therefore
     *          it must not be modified.
     */
    public WModel[] getWModels() {
        return widgetModels;
    }

    /**
     * Replaces the model array generated by guidesigner.
     * May only be called by the runtime. Do not call this method!
     */
    protected void setWModels(WModel[] models) {
        widgetModels=models;
    }

    /**
     * Returns a unique id to identify the type of this Page.
     * @return the typeId
     */
    public short getTypeId() {
        return CustomerEdit.Page3Class;
    }

    /**
     * Returns the component this page belongs to, casted to its actual type.
     * @return The Component. Never null.
     */
    public CustomerEdit getTypedComponent() {
        return (CustomerEdit) getComponent();
    }

    /**
     * Copies values of all attached widget models to attributes of the BusinessData instance variables.
     * Copies them for this page and all contained NotebookPages and statically embedded Pages
     * (embedded via XMAContainer in guidesigner)
     */
    public void modelToInstanceData() {
        atomicWMToBusinessData(getTypedComponent().getVodata());
    }

    /**
     * Copies attribute values of the BusinessData instance variables into their attached widget models.
     * This includes simple widget models and tables.
     * Copies them for this page and all contained NotebookPages and statically embedded Pages
     * (embedded via XMAContainer in guidesigner)
     */
    public void instanceDataToModel() {
        businessDataToAtomicWM(getTypedComponent().getVodata());
    }

    /**
     * Copies values of widget models to attributes of the provided BusinessData objects.
     */
    public void atomicWMToBusinessData(org.openxma.dsl.reference.dto.VODataView vodata) {
        vodata.setPVOBigDecimal(org.openxma.dsl.reference.types.valueobject.VOBigDecimal.newOrNull(vodata_pVOBigDecimal.toBigDecimal()));
        vodata.setPVODate(org.openxma.dsl.reference.types.valueobject.VODate.newOrNull(vodata_pVODate.toDate()));
        vodata.setPVOTimestamp(org.openxma.dsl.reference.types.valueobject.VOTimestamp.newOrNull(new java.sql.Timestamp(vodata_pVOTimestamp.toDate().getTime())));
        vodata.setPVODouble(org.openxma.dsl.reference.types.valueobject.VODouble.newOrNull(vodata_pVODouble.toDouble()));
        vodata.setPVOFloat(org.openxma.dsl.reference.types.valueobject.VOFloat.newOrNull(vodata_pVOFloat.toFLOAT()));
        vodata.setPVOInteger(org.openxma.dsl.reference.types.valueobject.VOInteger.newOrNull(vodata_pVOInteger.toINTEGER()));
        vodata.setPVOLong(org.openxma.dsl.reference.types.valueobject.VOLong.newOrNull(vodata_pVOLong.toLONG()));
        vodata.setPVOString(org.openxma.dsl.reference.types.valueobject.VOString.newOrNull(vodata_pVOString.toString()));
        vodata.setPVOBoolean(org.openxma.dsl.reference.types.valueobject.VOBoolean.newOrNull(Boolean.valueOf(vodata_pVOBoolean.isTrue())));
        vodata.setPVOI18Enumeration(org.openxma.dsl.reference.types.valueobject.VOI18Enumeration.newOrNull(vodata_pVOI18Enumeration.getSelected()));
    }

    /**
     * Copies attribute values of the provided BusinessDatas into widget models.
     */
    public void businessDataToAtomicWM(org.openxma.dsl.reference.dto.VODataView vodata) {
          vodata_pVOBigDecimal.set(org.openxma.dsl.platform.valueobject.ValueObject.valueOrNull(vodata.getPVOBigDecimal()));
          vodata_pVODate.set(org.openxma.dsl.platform.valueobject.ValueObject.valueOrNull(vodata.getPVODate()));
          vodata_pVOTimestamp.set(org.openxma.dsl.platform.valueobject.ValueObject.valueOrNull(vodata.getPVOTimestamp()));
          vodata_pVODouble.set(org.openxma.dsl.platform.valueobject.ValueObject.valueOrNull(vodata.getPVODouble()));
          vodata_pVOFloat.set(org.openxma.dsl.platform.valueobject.ValueObject.valueOrNull(vodata.getPVOFloat()));
          vodata_pVOInteger.set(org.openxma.dsl.platform.valueobject.ValueObject.valueOrNull(vodata.getPVOInteger()));
          vodata_pVOLong.set(org.openxma.dsl.platform.valueobject.ValueObject.valueOrNull(vodata.getPVOLong()));
          vodata_pVOString.set(org.openxma.dsl.platform.valueobject.ValueObject.valueOrNull(vodata.getPVOString()));
          vodata_pVOBoolean.set(org.openxma.dsl.platform.valueobject.ValueObject.valueOrNull(vodata.getPVOBoolean()));
          vodata_pVOI18Enumeration.set(org.openxma.dsl.platform.valueobject.ValueObject.valueOrNull(vodata.getPVOI18Enumeration()));
    }

    /**
     * Sets the given subpage. The method automatically chooses the
     * correct member variable to set.
     * @param child the subpage to set.
     */
    public void setChild(PageServer child) {
       // no subpages - nothing to do
    }

    /**
     * Removes the given subpage. The method automatically chooses the
     * correct member variable to clear.
     * @param child the subpage to set.
     */
    public void removeChild(PageServer child) {
       // no subpages - nothing to do
    }

}
