package org.openxma.dsl.reference.xma.order.client;

import java.util.Locale;
import java.util.ResourceBundle;
import org.eclipse.swt.*;
import org.eclipse.swt.events.*;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.widgets.*;
import at.spardat.xma.widgets.DatePicker;
import at.spardat.xma.page.*;
import at.spardat.xma.mdl.*;
import at.spardat.enterprise.util.*;
import at.spardat.xma.mdl.simple.*;
import at.spardat.enterprise.fmt.*;

/**
 * This class implements the generic client part of Page1.
 * It implements the widgets and models of the page.
 *
 */
public abstract class Page1Gen extends NotebookPage {
    Composite infoCompositeW;
    Composite infoComposite_set0W;
    Label infoComposite_set0_centered;
    Label customer_firstNameL;
    Text customer_firstNameW;
    ISimpleWMClient customer_firstName;
    Composite infoComposite_set1W;
    Label infoComposite_set1_centered;
    Label customer_lastNameL;
    Text customer_lastNameW;
    ISimpleWMClient customer_lastName;
    Composite infoComposite_set2W;
    Label infoComposite_set2_centered;
    Label orderState_orderNumberL;
    Text orderState_orderNumberW;
    ISimpleWMClient orderState_orderNumber;
    Composite infoComposite_set3W;
    Label infoComposite_set3_centered;
    Label orderState_storeIdL;
    Text orderState_storeIdW;
    ISimpleWMClient orderState_storeId;
    Composite infoComposite_set4W;
    Label infoComposite_set4_centered;
    Label orderState_placementDateL;
    DatePicker orderState_placementDateW;
    ISimpleWMClient orderState_placementDate;
    Composite infoComposite_set5W;
    Label infoComposite_set5_centered;
    Label orderState_deliveryDateL;
    DatePicker orderState_deliveryDateW;
    ISimpleWMClient orderState_deliveryDate;
    Composite infoComposite_set6W;
    Label infoComposite_set6_centered;
    Label orderState_orderStateL;
    Text orderState_orderStateW;
    ISimpleWMClient orderState_orderState;
    WModel[] widgetModels;
    Control[] widgets;

    /**
     * Constructs the Page1Gen.
     * @param notebook the Notebook this page belongs to.
     */
    public Page1Gen(Notebook notebook) {
        super(notebook,false);
        createModels();
    }

    /**
     * Create and initialize the WidgetModels of the page.
     * Subpages which are not lazy are created too.
     */
    public void createModels() {
        Locale locale = getComponent().getContext().getLocale();
        IFmt formatter;
        CompoundValidator compound;
        customer_firstName = new SimpleWMClient((short) 0, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(25);
        compound = new CompoundValidator(formatter);
        formatter = AStringFmt.getInstance(25);
        compound.setFormatter(formatter);
        formatter = compound;
        customer_firstName.setFmt(formatter);
        customer_lastName = new SimpleWMClient((short) 1, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(25);
        compound = new CompoundValidator(formatter);
        formatter = AStringFmt.getInstance(25);
        compound.setFormatter(formatter);
        formatter = compound;
        customer_lastName.setFmt(formatter);
        orderState_orderNumber = new SimpleWMClient((short) 2, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        compound = new CompoundValidator(formatter);
        formatter = AStringFmt.getInstance(-1);
        compound.setFormatter(formatter);
        formatter = compound;
        orderState_orderNumber.setFmt(formatter);
        orderState_storeId = new SimpleWMClient((short) 3, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        compound = new CompoundValidator(formatter);
        formatter = AStringFmt.getInstance(-1);
        compound.setFormatter(formatter);
        formatter = compound;
        orderState_storeId.setFmt(formatter);
        orderState_placementDate = new SimpleWMClient((short) 4, Types.T_DATE, this);
        formatter = ADateFmt.getInstance(ADateFmt.MEDIUM, locale);
        compound = new CompoundValidator(formatter);
        formatter = ADateFmt.getInstance(ADateFmt.MEDIUM, locale);
        compound.setFormatter(formatter);
        formatter = compound;
        orderState_placementDate.setFmt(formatter);
        orderState_deliveryDate = new SimpleWMClient((short) 5, Types.T_DATE, this);
        formatter = ADateFmt.getInstance(ADateFmt.MEDIUM, locale);
        compound = new CompoundValidator(formatter);
        formatter = ADateFmt.getInstance(ADateFmt.MEDIUM, locale);
        compound.setFormatter(formatter);
        formatter = compound;
        orderState_deliveryDate.setFmt(formatter);
        orderState_orderState = new SimpleWMClient((short) 6, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(33);
        compound = new CompoundValidator(formatter);
        formatter = AStringFmt.getInstance(33);
        compound.setFormatter(formatter);
        formatter = compound;
        orderState_orderState.setFmt(formatter);

        widgetModels = new WModel[] { (WModel) customer_firstName, (WModel) customer_lastName, (WModel) orderState_orderNumber, (WModel) orderState_storeId, (WModel) orderState_placementDate, (WModel) orderState_deliveryDate, (WModel) orderState_orderState };
        getComponent().registerPageModel(this);
    }

    /**
     * Indicate if the WidgetModels are already created.
     * @return true if the WidgetModels exist.
     */
    public boolean hasModels() {
        return widgetModels != null;
    }

    /**
     * Remove all WidgetModels of the page.
     */
    public void removeWidgetModels() {
        customer_firstName = null;
        customer_lastName = null;
        orderState_orderNumber = null;
        orderState_storeId = null;
        orderState_placementDate = null;
        orderState_deliveryDate = null;
        orderState_orderState = null;
        widgetModels = null;
    }

    /**
     * Returns an array of all WidgetModels of this page.
     * @return array of WidgetModels. The returned array is not a copy, therefore
     *          it must not be modified.
     */
    public WModel[] getWModels() {
        return widgetModels;
    }

    /**
     * Replaces the model array generated by guidesigner.
     * May only be called by the runtime. Do not call this method!
     */
    protected void setWModels(WModel[] models) {
        widgetModels=models;
    }

    /**
     * Returns a unique id to identify the type of this Page.
     * @return the typeId
     */
    public short getTypeId() {
        return Order.Page1Class;
    }

    /**
     * Returns the component this page belongs to, casted to its actual type.
     * @return The Component. Never null.
     */
    public Order getTypedComponent() {
        return (Order) getComponent();
    }

    /**
     * Returns an array of all Widgets of this page.
     * @return array of Widgets. The returned array is not a copy, therefore
     *          it must not be modified.
     */
    public Control[] getWidgets() {
        return widgets;
    }

    /**
     * Replaces the widget array generated by guidesigner.
     * May only be called by the runtime. Do not call this method!
     */
    protected void setWidgets(Control[] widgets) {
        this.widgets=widgets;
    }

    /**
     * Create and initialize all SWT-Widgets of the page.
     * It <br>
     * <ul>
     * <li> instantiates the Widgets </li>
     * <li> sets constant texts (Title, Labels, Tooltips) and Images </li>
     * <li> registers the eventadapter </li>
     * <li> defines the Layout (Attachments, Distances, Sizes) </li>
     * <li> sets the focus </li>
     * <li> defines the Taborder </li>
     * </ul>
     */
    protected void createWidgets() {
        FormData data;
        Control[] tabOrder;
        EventAdapter adapter = new EventAdapter(this);
        Locale locale = getComponent().getContext().getLocale();
        ResourceBundle messages = ResourceBundle.getBundle("org.openxma.dsl.reference.xma.order.client.Order",locale);
        final Scaler scaler = Scaler.getInstance(getComposite());
        Control lastControl;

        Composite pageCompositePage1W = getComposite();
        FormLayout layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        pageCompositePage1W.setLayout(layout);

        infoCompositeW = new Composite(pageCompositePage1W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        infoCompositeW.setLayout(layout);
        infoCompositeW.setData("WIDGET_ID","infoCompositeW");

        infoComposite_set0W = new Composite(infoCompositeW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        infoComposite_set0W.setLayout(layout);
        infoComposite_set0W.setData("WIDGET_ID","infoComposite_set0W");

        infoComposite_set0_centered = new Label (infoComposite_set0W,SWT.LEFT);
        infoComposite_set0_centered.setVisible(false);
        infoComposite_set0_centered.setData("WIDGET_ID","infoComposite_set0_centered");

        customer_firstNameL = new Label (infoComposite_set0W,SWT.LEFT|SWT.WRAP);
        customer_firstNameL.setText(messages.getString("Page1.customer_firstNameL"));
        customer_firstNameL.setData("WIDGET_ID","customer_firstNameL");

        customer_firstNameW = new Text(infoComposite_set0W, SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        customer_firstNameW.setToolTipText(messages.getString("Page1.customer_firstNameWTip"));
        customer_firstNameW.setData("WIDGET_ID","customer_firstNameW");
        customer_firstNameW.addFocusListener(adapter);
        customer_firstNameW.addModifyListener(adapter);
        customer_firstNameW.addVerifyListener(adapter);

        infoComposite_set1W = new Composite(infoCompositeW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        infoComposite_set1W.setLayout(layout);
        infoComposite_set1W.setData("WIDGET_ID","infoComposite_set1W");

        infoComposite_set1_centered = new Label (infoComposite_set1W,SWT.LEFT);
        infoComposite_set1_centered.setVisible(false);
        infoComposite_set1_centered.setData("WIDGET_ID","infoComposite_set1_centered");

        customer_lastNameL = new Label (infoComposite_set1W,SWT.LEFT|SWT.WRAP);
        customer_lastNameL.setText(messages.getString("Page1.customer_lastNameL"));
        customer_lastNameL.setData("WIDGET_ID","customer_lastNameL");

        customer_lastNameW = new Text(infoComposite_set1W, SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        customer_lastNameW.setToolTipText(messages.getString("Page1.customer_lastNameWTip"));
        customer_lastNameW.setData("WIDGET_ID","customer_lastNameW");
        customer_lastNameW.addFocusListener(adapter);
        customer_lastNameW.addModifyListener(adapter);
        customer_lastNameW.addVerifyListener(adapter);

        infoComposite_set2W = new Composite(infoCompositeW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        infoComposite_set2W.setLayout(layout);
        infoComposite_set2W.setData("WIDGET_ID","infoComposite_set2W");

        infoComposite_set2_centered = new Label (infoComposite_set2W,SWT.LEFT);
        infoComposite_set2_centered.setVisible(false);
        infoComposite_set2_centered.setData("WIDGET_ID","infoComposite_set2_centered");

        orderState_orderNumberL = new Label (infoComposite_set2W,SWT.LEFT|SWT.WRAP);
        orderState_orderNumberL.setText(messages.getString("Page1.orderState_orderNumberL"));
        orderState_orderNumberL.setData("WIDGET_ID","orderState_orderNumberL");

        orderState_orderNumberW = new Text(infoComposite_set2W, SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        orderState_orderNumberW.setToolTipText(messages.getString("Page1.orderState_orderNumberWTip"));
        orderState_orderNumberW.setData("WIDGET_ID","orderState_orderNumberW");
        orderState_orderNumberW.addFocusListener(adapter);
        orderState_orderNumberW.addModifyListener(adapter);
        orderState_orderNumberW.addVerifyListener(adapter);

        infoComposite_set3W = new Composite(infoCompositeW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        infoComposite_set3W.setLayout(layout);
        infoComposite_set3W.setData("WIDGET_ID","infoComposite_set3W");

        infoComposite_set3_centered = new Label (infoComposite_set3W,SWT.LEFT);
        infoComposite_set3_centered.setVisible(false);
        infoComposite_set3_centered.setData("WIDGET_ID","infoComposite_set3_centered");

        orderState_storeIdL = new Label (infoComposite_set3W,SWT.LEFT|SWT.WRAP);
        orderState_storeIdL.setText(messages.getString("Page1.orderState_storeIdL"));
        orderState_storeIdL.setData("WIDGET_ID","orderState_storeIdL");

        orderState_storeIdW = new Text(infoComposite_set3W, SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        orderState_storeIdW.setToolTipText(messages.getString("Page1.orderState_storeIdWTip"));
        orderState_storeIdW.setData("WIDGET_ID","orderState_storeIdW");
        orderState_storeIdW.addFocusListener(adapter);
        orderState_storeIdW.addModifyListener(adapter);
        orderState_storeIdW.addVerifyListener(adapter);

        infoComposite_set4W = new Composite(infoCompositeW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        infoComposite_set4W.setLayout(layout);
        infoComposite_set4W.setData("WIDGET_ID","infoComposite_set4W");

        infoComposite_set4_centered = new Label (infoComposite_set4W,SWT.LEFT);
        infoComposite_set4_centered.setVisible(false);
        infoComposite_set4_centered.setData("WIDGET_ID","infoComposite_set4_centered");

        orderState_placementDateL = new Label (infoComposite_set4W,SWT.LEFT|SWT.WRAP);
        orderState_placementDateL.setText(messages.getString("Page1.orderState_placementDateL"));
        orderState_placementDateL.setData("WIDGET_ID","orderState_placementDateL");

        orderState_placementDateW = new DatePicker(infoComposite_set4W, SWT.SINGLE|SWT.BORDER|SWT.LEFT,DatePicker.RED_WEEKEND);
        orderState_placementDateW.setDatePickerLocale(locale);
        orderState_placementDateW.setToolTipText(messages.getString("Page1.orderState_placementDateWTip"));
        orderState_placementDateW.setData("WIDGET_ID","orderState_placementDateW");
        orderState_placementDateW.getDateTextField().addFocusListener(adapter);
        orderState_placementDateW.getDateTextField().addModifyListener(adapter);
        orderState_placementDateW.getDateTextField().addVerifyListener(adapter);

        infoComposite_set5W = new Composite(infoCompositeW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        infoComposite_set5W.setLayout(layout);
        infoComposite_set5W.setData("WIDGET_ID","infoComposite_set5W");

        infoComposite_set5_centered = new Label (infoComposite_set5W,SWT.LEFT);
        infoComposite_set5_centered.setVisible(false);
        infoComposite_set5_centered.setData("WIDGET_ID","infoComposite_set5_centered");

        orderState_deliveryDateL = new Label (infoComposite_set5W,SWT.LEFT|SWT.WRAP);
        orderState_deliveryDateL.setText(messages.getString("Page1.orderState_deliveryDateL"));
        orderState_deliveryDateL.setData("WIDGET_ID","orderState_deliveryDateL");

        orderState_deliveryDateW = new DatePicker(infoComposite_set5W, SWT.SINGLE|SWT.BORDER|SWT.LEFT,DatePicker.RED_WEEKEND);
        orderState_deliveryDateW.setDatePickerLocale(locale);
        orderState_deliveryDateW.setToolTipText(messages.getString("Page1.orderState_deliveryDateWTip"));
        orderState_deliveryDateW.setData("WIDGET_ID","orderState_deliveryDateW");
        orderState_deliveryDateW.getDateTextField().addFocusListener(adapter);
        orderState_deliveryDateW.getDateTextField().addModifyListener(adapter);
        orderState_deliveryDateW.getDateTextField().addVerifyListener(adapter);

        infoComposite_set6W = new Composite(infoCompositeW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        infoComposite_set6W.setLayout(layout);
        infoComposite_set6W.setData("WIDGET_ID","infoComposite_set6W");

        infoComposite_set6_centered = new Label (infoComposite_set6W,SWT.LEFT);
        infoComposite_set6_centered.setVisible(false);
        infoComposite_set6_centered.setData("WIDGET_ID","infoComposite_set6_centered");

        orderState_orderStateL = new Label (infoComposite_set6W,SWT.LEFT|SWT.WRAP);
        orderState_orderStateL.setText(messages.getString("Page1.orderState_orderStateL"));
        orderState_orderStateL.setData("WIDGET_ID","orderState_orderStateL");

        orderState_orderStateW = new Text(infoComposite_set6W, SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        orderState_orderStateW.setToolTipText(messages.getString("Page1.orderState_orderStateWTip"));
        orderState_orderStateW.setData("WIDGET_ID","orderState_orderStateW");
        orderState_orderStateW.addFocusListener(adapter);
        orderState_orderStateW.addModifyListener(adapter);
        orderState_orderStateW.addVerifyListener(adapter);

        widgets = new Control[] { infoCompositeW, infoComposite_set0W, infoComposite_set0_centered, customer_firstNameL, customer_firstNameW, infoComposite_set1W, infoComposite_set1_centered, customer_lastNameL, customer_lastNameW, infoComposite_set2W, infoComposite_set2_centered, orderState_orderNumberL, orderState_orderNumberW, infoComposite_set3W, infoComposite_set3_centered, orderState_storeIdL, orderState_storeIdW, infoComposite_set4W, infoComposite_set4_centered, orderState_placementDateL, orderState_placementDateW, infoComposite_set5W, infoComposite_set5_centered, orderState_deliveryDateL, orderState_deliveryDateW, infoComposite_set6W, infoComposite_set6_centered, orderState_orderStateL, orderState_orderStateW };

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(10));
        infoCompositeW.setLayoutData(data);

        lastControl=null;
        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        infoComposite_set0W.setLayoutData(data);
        lastControl=infoComposite_set0W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        infoComposite_set1W.setLayoutData(data);
        lastControl=infoComposite_set1W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        infoComposite_set2W.setLayoutData(data);
        lastControl=infoComposite_set2W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        infoComposite_set3W.setLayoutData(data);
        lastControl=infoComposite_set3W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        infoComposite_set4W.setLayoutData(data);
        lastControl=infoComposite_set4W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        infoComposite_set5W.setLayoutData(data);
        lastControl=infoComposite_set5W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        infoComposite_set6W.setLayoutData(data);
        lastControl=infoComposite_set6W;

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        infoComposite_set0_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(infoComposite_set0_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        customer_firstNameL.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(175);
        data.left = new FormAttachment(customer_firstNameL,scaler.convertXToCurrent(3),SWT.RIGHT);
        data.top = new FormAttachment(infoComposite_set0_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        customer_firstNameW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        infoComposite_set1_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(infoComposite_set1_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        customer_lastNameL.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(175);
        data.left = new FormAttachment(customer_lastNameL,scaler.convertXToCurrent(3),SWT.RIGHT);
        data.top = new FormAttachment(infoComposite_set1_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        customer_lastNameW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        infoComposite_set2_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(infoComposite_set2_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        orderState_orderNumberL.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(orderState_orderNumberL,scaler.convertXToCurrent(3),SWT.RIGHT);
        data.top = new FormAttachment(infoComposite_set2_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        orderState_orderNumberW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        infoComposite_set3_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(infoComposite_set3_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        orderState_storeIdL.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(orderState_storeIdL,scaler.convertXToCurrent(3),SWT.RIGHT);
        data.top = new FormAttachment(infoComposite_set3_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        orderState_storeIdW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        infoComposite_set4_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(infoComposite_set4_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        orderState_placementDateL.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(90);
        data.left = new FormAttachment(orderState_placementDateL,scaler.convertXToCurrent(3),SWT.RIGHT);
        data.top = new FormAttachment(infoComposite_set4_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        orderState_placementDateW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        infoComposite_set5_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(infoComposite_set5_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        orderState_deliveryDateL.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(90);
        data.left = new FormAttachment(orderState_deliveryDateL,scaler.convertXToCurrent(3),SWT.RIGHT);
        data.top = new FormAttachment(infoComposite_set5_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        orderState_deliveryDateW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        infoComposite_set6_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(infoComposite_set6_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        orderState_orderStateL.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(231);
        data.left = new FormAttachment(orderState_orderStateL,scaler.convertXToCurrent(3),SWT.RIGHT);
        data.top = new FormAttachment(infoComposite_set6_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        orderState_orderStateW.setLayoutData(data);


        tabOrder = new Control[1];
        tabOrder[0] = infoCompositeW;
        pageCompositePage1W.setTabList(tabOrder);
        tabOrder = new Control[7];
        tabOrder[0] = infoComposite_set0W;
        tabOrder[1] = infoComposite_set1W;
        tabOrder[2] = infoComposite_set2W;
        tabOrder[3] = infoComposite_set3W;
        tabOrder[4] = infoComposite_set4W;
        tabOrder[5] = infoComposite_set5W;
        tabOrder[6] = infoComposite_set6W;
        infoCompositeW.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = customer_firstNameW;
        infoComposite_set0W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = customer_lastNameW;
        infoComposite_set1W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = orderState_orderNumberW;
        infoComposite_set2W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = orderState_storeIdW;
        infoComposite_set3W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = orderState_placementDateW;
        infoComposite_set4W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = orderState_deliveryDateW;
        infoComposite_set5W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = orderState_orderStateW;
        infoComposite_set6W.setTabList(tabOrder);
    }

    /**
     * Remove all Widgets of the page after they have been disposed.
     */
    public void removeWidgets() {
        infoCompositeW = null;
        infoComposite_set0W = null;
        infoComposite_set0_centered = null;
        customer_firstNameL = null;
        customer_firstNameW = null;
        infoComposite_set1W = null;
        infoComposite_set1_centered = null;
        customer_lastNameL = null;
        customer_lastNameW = null;
        infoComposite_set2W = null;
        infoComposite_set2_centered = null;
        orderState_orderNumberL = null;
        orderState_orderNumberW = null;
        infoComposite_set3W = null;
        infoComposite_set3_centered = null;
        orderState_storeIdL = null;
        orderState_storeIdW = null;
        infoComposite_set4W = null;
        infoComposite_set4_centered = null;
        orderState_placementDateL = null;
        orderState_placementDateW = null;
        infoComposite_set5W = null;
        infoComposite_set5_centered = null;
        orderState_deliveryDateL = null;
        orderState_deliveryDateW = null;
        infoComposite_set6W = null;
        infoComposite_set6_centered = null;
        orderState_orderStateL = null;
        orderState_orderStateW = null;
        widgets = null;
    }


    /**
     * Attaches all WidgetModels of the page to there corresponding Widgets.
     */
    public void attachUIImpl() throws AttachmentExceptionClient {
        customer_firstNameW.setData(customer_firstName.getUIDelegate());
        customer_firstName.getUIDelegate().attachUI(customer_firstNameW,customer_firstNameL);
        customer_lastNameW.setData(customer_lastName.getUIDelegate());
        customer_lastName.getUIDelegate().attachUI(customer_lastNameW,customer_lastNameL);
        orderState_orderNumberW.setData(orderState_orderNumber.getUIDelegate());
        orderState_orderNumber.getUIDelegate().attachUI(orderState_orderNumberW,orderState_orderNumberL);
        orderState_storeIdW.setData(orderState_storeId.getUIDelegate());
        orderState_storeId.getUIDelegate().attachUI(orderState_storeIdW,orderState_storeIdL);
        orderState_placementDateW.getDateTextField().setData(orderState_placementDate.getUIDelegate());
        orderState_placementDate.getUIDelegate().attachUI(orderState_placementDateW.getDateTextField(),orderState_placementDateL);
        orderState_deliveryDateW.getDateTextField().setData(orderState_deliveryDate.getUIDelegate());
        orderState_deliveryDate.getUIDelegate().attachUI(orderState_deliveryDateW.getDateTextField(),orderState_deliveryDateL);
        orderState_orderStateW.setData(orderState_orderState.getUIDelegate());
        orderState_orderState.getUIDelegate().attachUI(orderState_orderStateW,orderState_orderStateL);
    }

    /**
     * Enables or disables Widgets according to the current state of the page.
     * This method is called every time the content of any WizardModel of the
     * Page may have been changed. <br>
     * This method is called immediately after {@link #determineState()}.
     */
    public void stateChanged() {

        customer_firstName.setMandatory(true);
        customer_lastName.setMandatory(true);
        orderState_orderNumber.setMandatory(true);
        orderState_storeId.setMandatory(true);
        orderState_placementDate.setMandatory(true);
        orderState_deliveryDate.setMandatory(false);
        orderState_orderState.setMandatory(true);
    }

    /**
     * Calls the clientevent configured for the widget of the event.
     *
     * @param event the SWT-Event that happened.
     * @param type the type of the Event, as defined by the event type constants in class SWT.
     */
    protected void clientEvent(SelectionEvent event,int type) {
    }

    /**
     * Creates the coresponding TabItem
     */
    protected TabItem createTabItem(TabFolder tabfolder1W,int index) {
        Locale locale = getComponent().getContext().getLocale();
        ResourceBundle messages = ResourceBundle.getBundle("org.openxma.dsl.reference.xma.order.client.Order",locale);

        TabItem page1W = new TabItem (tabfolder1W, SWT.NULL, index);
        page1W.setText(messages.getString("Page1"));
        page1W.setControl(getComposite());
        page1W.setData(this);

        return page1W;
    }
}
